c
c$Id: loadcom.f,v 1.1 1993/08/30 23:30:15 gg502 Exp $
c
c***********************************************************************
c
c-->  Load often used constants and logical file numbers, and conversion
c     factors.
c
c     Reference 1:  Atoms and Molecules, Karplus and Porter, 1970.
c     Reference 2:  Quantum Chemistry, Levine Appendix A.
c
c***********************************************************************
c
      subroutine loadcom
      implicit real*8 ( a-h,o-z)
      common /iostuff/ ir,iw,ick,ints
      common /mathcon/ pi
      common /phycon/  a0
      common /conv/    au2ev
c
c--> I/O constants
c
      ints=3
      ir=5
      iw=6
      ick=10
c
c--> Mathematical constants.  (Numbers without units.)
c
      pi = dacos(-1.0d0)
c
c--> Physical constants.
c
c--> Bohr radius.  Reference 2.
c
      a0 = 5.29177d-1  
c
c--> Conversion factors.
c
c--> Hartrees to electron volts.  Reference 1.
c
      au2ev = 2.72107d+1
c
c--> Hartrees to kcal/mol.  Reference 1.
c
      au2kcal = 6.27503d+2
c
      return
      end

