      subroutine check_time
      implicit none
#include "mafdecls.h"
#include "global.h"
#include "tcgmsg.h"
c     
      integer n
      parameter (n = 256)
c
      double precision buf(n, n), used, time_per_word, time_per_call,
     $     bandwidth
      integer len, ntimes, ncalls, itime, ilo, ihi, jlo, jhi, g_a, nproc
c
      call dfill(n*n, 0.0d0, buf, 1)
c
      if (.not. ga_create(MT_DBL, n, n, 'a', 1, 1, g_a))
     $     call errquit('check_time: ga_create failed', 0)
c
      write(6,2)
 2    format(
     $     ' nproc  len   used  ncall   t/calls   t/words   rate'/
     $     ' -----  ---  -----  -----   -------   -------   ----')
c
      len = 1
 10   continue
c
      ntimes = 1
c
      ncalls = 0
      used = - tcgtime()
      do itime = 1, ntimes
         do jlo = 1, n, len
            jhi = min(n, jlo+len-1)
            do ilo = 1, n, len
               ihi = min(n, ilo+len-1)
               ncalls = ncalls + 1
               call ga_acc(g_a, ilo, ihi, jlo, jhi, buf, len, 1.0d0)
            enddo
         enddo
      enddo
      used = used + tcgtime()
c
      time_per_call = used / ncalls
      time_per_word = used / (ntimes*n*n)
      bandwidth = 1.0d0 / time_per_word
      write(6,1) nproc, len, used, ncalls, time_per_call, time_per_word,
     $     bandwidth
 1    format(1x,i5,i5,f7.2,i7,1x,1pd9.2,1x,1pd9.2,1x,1pd9.2)
c
      len = len * 2
      if (len .le. n) goto 10
c
      if (.not. ga_destroy(g_a))
     $     call errquit('check_time: destroy failed', 0)
c
      end

