      subroutine ga_zero(g_a)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a
c
      integer type, dim1, dim2, ilo, ihi, jlo, jhi,
     $     ldim1, ldim2, gbase
      character*40 aname
c
c     On the delta just need to get the pointer to the data
c     and zero it ... under TCGMSG need to send a message to 
c     the data server and have it do the work
c
c     Once we nix the TCGMSG support there is no need for
c     this routine to be including globalp.h (using me and nserver)
c
      call ga_check_handle(g_a, 'ga_zero')
c
      call ga_sync()
c
      if (.not.oserver) then
         call ga_snd_req(g_a, 0, 0, 0, 0, 0, 0, GA_OP_ZER, me)
      else
         call ga_inquire(g_a, aname, type, dim1, dim2)
         call ga_distribution(g_a, me, ilo, ihi, jlo, jhi,
     $        gbase)
         ldim1 = (ihi-ilo+1)
         ldim2 = (jhi-jlo+1)
c
         if (gbase .ne. 0) then
            if (type .eq. MT_DBL) then
               call dfill(ldim1*ldim2, 0.0d0, dbl_mb(gbase), 1)
            else if (type .eq. MT_INT) then
               call ifill(ldim1*ldim2, 0, int_mb(gbase), 1)
            else
               call errquit('ga_zero: invalid type '//aname, type)
            endif
         else
            if (ldim1*ldim2 .ne. 0)
     $           call errquit('ga_zero: no index?'//aname, g_a)
         endif
      endif
c
      call ga_sync()
c
      end
      double precision function ga_ddot(g_a, g_b)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a, g_b
c
      integer ldim1, ldim2
      integer atype, ailo, aihi, ajlo, ajhi, adim1, adim2, abase
      integer btype, bilo, bihi, bjlo, bjhi, bdim1, bdim2, bbase
      character*40 aname, bname
      double precision sum
c
      double precision ddot
      external ddot
c
c     On the delta just need to get the pointers to the data
c     and dot them ... under TCGMSG need to send a message to 
c     the data server and have it do the work
c
c     Once we nix the TCGMSG support there is no need for
c     this routine to be including globalp.h (using me and nserver)
c
      call ga_check_handle(g_a, 'ga_ddot')
      call ga_check_handle(g_b, 'ga_ddot')
c
      call ga_sync()
c
      if (.not. oserver) then
         call ga_snd_req(g_a, g_b, 0, 0, 0, 0, 0, GA_OP_DDT, me)
         sum = 0.0d0
         call dgop(GA_TYPE_GSM, sum, 1, '+')
      else
         call ga_inquire(g_a, aname, atype, adim1, adim2)
         call ga_distribution(g_a, me, ailo, aihi,
     $        ajlo, ajhi, abase)
         call ga_inquire(g_b, bname, btype, bdim1, bdim2)
         call ga_distribution(g_b, me, bilo, bihi,
     $        bjlo, bjhi, bbase)
         if (atype.ne.btype .or. atype.ne.MT_DBL)
     $        call errquit('ga_ddot: types not correct', 0)
         if (adim1.ne.bdim1 .or. adim2.ne.bdim2)
     $        call errquit('ga_ddot: arrays not conformant', 0)
         if (ailo.ne.bilo .or. aihi.ne.bihi .or.
     $        ajlo.ne.bjlo .or. ajhi.ne.bjhi)
     $        call errquit('ga_ddot: distribution not identical',0)
         ldim1 = (aihi-ailo+1)
         ldim2 = (ajhi-ajlo+1)
         if (abase*bbase .ne. 0) then
            sum = ddot(ldim1*ldim2, dbl_mb(abase), 1, dbl_mb(bbase), 1)
         else
            if (ldim1*ldim2 .ne. 0)
     $           call errquit('ga_ddot: no index?'//aname//bname, g_a)
            sum = 0.0d0
         endif
         call dgop(GA_TYPE_GSM, sum, 1, '+') ! Compute and data servers
      endif
c
      ga_ddot = sum
      call ga_sync()
c
      end
      subroutine ga_dadd(alpha, g_a, beta, g_b, g_c)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a, g_b, g_c
      double precision alpha, beta
c
      integer ldim1, ldim2, i
      integer atype, ailo, aihi, ajlo, ajhi, adim1, adim2, abase
      integer btype, bilo, bihi, bjlo, bjhi, bdim1, bdim2, bbase
      integer ctype, cilo, cihi, cjlo, cjhi, cdim1, cdim2, cbase
      character*40 aname, bname, cname
c
c     On the delta just need to get the pointers to the data
c     and add ... under TCGMSG need to send a message to 
c     the data server and have it do the work
c
c     Once we nix the TCGMSG support there is no need for
c     this routine to be including globalp.h (using me and nserver)
c
      call ga_check_handle(g_a, 'ga_add a')
      call ga_check_handle(g_b, 'ga_add b')
      call ga_check_handle(g_c, 'ga_add c')
c
      call ga_sync()
c
      if (.not. oserver) then
         call ga_snd_req(g_a, g_b, g_c, 0, 0, 0, 0, GA_OP_ADD, me)
         tmp(1) = alpha
         tmp(2) = beta
         call ga_snd_msg(GA_TYPE_ADD, tmp, mdtob(2), me+nserver)
      else
         call ga_inquire(g_a, aname, atype, adim1, adim2)
         call ga_distribution(g_a, me, ailo, aihi,
     $        ajlo, ajhi, abase)
         call ga_inquire(g_b, bname, btype, bdim1, bdim2)
         call ga_distribution(g_b, me, bilo, bihi,
     $        bjlo, bjhi, bbase)
         call ga_inquire(g_c, cname, ctype, cdim1, cdim2)
         call ga_distribution(g_c, me, cilo, cihi,
     $        cjlo, cjhi, cbase)
c
         if (atype.ne.btype .or. atype.ne.ctype .or. atype.ne.MT_DBL)
     $        call errquit('ga_add: types do not match', 0)
         if (adim1.ne.bdim1 .or. adim2.ne.bdim2 .or.
     $       adim1.ne.cdim1 .or. adim2.ne.cdim2)
     $        call errquit('ga_add: arrays not conformant', 0)
         if (ailo.ne.bilo .or. aihi.ne.bihi .or.
     $       ajlo.ne.bjlo .or. ajhi.ne.bjhi .or.
     $       ailo.ne.cilo .or. aihi.ne.cihi .or.
     $       ajlo.ne.cjlo .or. ajhi.ne.cjhi)
     $        call errquit('ga_add: distribution not identical',0)
         ldim1 = (aihi-ailo+1)
         ldim2 = (ajhi-ajlo+1)
         if (abase*bbase*cbase .ne. 0) then
            do i = 0, ldim1*ldim2-1
               dbl_mb(cbase+i) =
     $              alpha*dbl_mb(abase+i) + beta*dbl_mb(bbase+i)
            enddo
         else
            if (ldim1*ldim2 .ne. 0)
     $           call errquit('ga_dadd: no index?'//aname//bname, g_a)
         endif
      endif
c
      call ga_sync()
c
      end
      subroutine ga_dscal(g_a, s)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a
      double precision s
c
      integer type, dim1, dim2, ilo, ihi, jlo, jhi,
     $     ldim1, ldim2, gbase
      character*40 aname
c
c     On the delta just need to get the pointer to the data
c     and scale it ... under TCGMSG need to send a message to 
c     the data server and have it do the work
c
c     Once we nix the TCGMSG support there is no need for
c     this routine to be including globalp.h (using me and nserver)
c
      call ga_check_handle(g_a, 'ga_dscal')
c
      call ga_sync()
c
      if (.not.oserver) then
         call ga_snd_req(g_a, 0, 0, 0, 0, 0, 0, GA_OP_DSC, me)
         call ga_snd_msg(GA_TYPE_DSC, s, mdtob(1), me+nserver)
      else
         call ga_inquire(g_a, aname, type, dim1, dim2)
         if (type .ne. MT_DBL)
     $        call errquit('ga_dscal: double precision only', type)
         call ga_distribution(g_a, me, ilo, ihi, jlo, jhi,
     $        gbase)
         ldim1 = (ihi-ilo+1)
         ldim2 = (jhi-jlo+1)
c
         if (gbase .ne. 0) then
            call dscal(ldim1*ldim2, s, dbl_mb(gbase), 1)
         else
            if (ldim1*ldim2 .ne. 0)
     $           call errquit('ga_zero: no index?'//aname, g_a)
         endif
      endif
c
      call ga_sync()
c
      end
      double precision function ga_copy(g_a, g_b)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a, g_b
c
      integer ldim1, ldim2
      integer atype, ailo, aihi, ajlo, ajhi, adim1, adim2, abase
      integer btype, bilo, bihi, bjlo, bjhi, bdim1, bdim2, bbase
      character*40 aname, bname
c
c     On the delta just need to get the pointers to the data
c     and do the copy ... under TCGMSG need to send a message to 
c     the data server and have it do the work
c
c     Once we nix the TCGMSG support there is no need for
c     this routine to be including globalp.h (using me and nserver)
c
      call ga_check_handle(g_a, 'ga_copy')
      call ga_check_handle(g_b, 'ga_copy')
c
      call ga_sync()
c
      if (.not. oserver) then
         call ga_snd_req(g_a, g_b, 0, 0, 0, 0, 0, GA_OP_COP, me)
      else
         call ga_inquire(g_a, aname, atype, adim1, adim2)
         call ga_distribution(g_a, me, ailo, aihi,
     $        ajlo, ajhi, abase)
         call ga_inquire(g_b, bname, btype, bdim1, bdim2)
         call ga_distribution(g_b, me, bilo, bihi,
     $        bjlo, bjhi, bbase)
         if (atype.ne.btype)
     $        call errquit('ga_copy: types must match', 0)
         if (adim1.ne.bdim1 .or. adim2.ne.bdim2)
     $        call errquit('ga_copy: arrays not conformant', 0)
         if (ailo.ne.bilo .or. aihi.ne.bihi .or.
     $        ajlo.ne.bjlo .or. ajhi.ne.bjhi)
     $        call errquit('ga_copy: distribution not identical',0)
         ldim1 = (aihi-ailo+1)
         ldim2 = (ajhi-ajlo+1)
         if (abase*bbase .ne. 0) then
            if (atype .eq. MT_DBL) then
               call dcopy(ldim1*ldim2, dbl_mb(abase), 1, 
     $              dbl_mb(bbase), 1)
            else
               call icopy(ldim1*ldim2, int_mb(abase), 1, 
     $              int_mb(bbase), 1)
            endif
         else
            if (ldim1*ldim2 .ne. 0)
     $           call errquit('ga_copy: no index?'//aname//bname, g_a)
         endif
      endif
c
      call ga_sync()
c
      end
