      block data ga_block_data
      implicit none
#include "globalp.h"
      data actv/max_global_array*.false./
c
      end
      subroutine ga_snd_req(i1, i2, i3, i4, i5, i6, i7, i8, iproc)
      implicit none
#include "globalp.h"
#include "tcgmsg.h"
c
      integer i1, i2, i3, i4, i5, i6, i7, i8, iproc
      integer msg(8), ack, from, len, to
c     
      msg(1) = i1
      msg(2) = i2
      msg(3) = i3
      msg(4) = i4
      msg(5) = i5
      msg(6) = i6
      msg(7) = i7
      msg(8) = i8
c
      to     = iproc
#if defined(DATA_SERVER)
      to = to + nserver
#endif
      call ga_snd_msg(GA_TYPE_REQ, msg, mitob(8), to)
*      if (msg(8) .ne. GA_OP_GET) then
         call ga_rcv_msg(GA_TYPE_ACK, ack, mitob(1), len, to, from)
*      endif
c
      end
      subroutine ga_snd_msg(type, buf, buflen, to)
      implicit none
#include "globalp.h"
      integer type, buf(*), buflen, to
c
c     Wrapper around native message passing routines
c
#if defined(TCGMSG)
      call snd(type, buf, buflen, to, 1)
#elif defined(NX)
      integer ctype
c
c     Must munge type so that crecv can match type & node
c
      if (type .eq. GA_TYPE_REQ) then
         ctype = type           ! Will be victim of wild card receive
      else
         ctype = type + me*32768
      endif
      call csend(ctype, buf, buflen, to, 0)
#else
      call errquit('ga_snd_msg: incorrect compilation flags', 0)
#endif
c
      end
      subroutine ga_rcv_msg(type, buf, buflen, msglen, from, whofrom)
      implicit none
      integer type, buf(*), buflen, msglen, from, whofrom
c
#if defined(TCGMSG)
      call rcv(type, buf, buflen, msglen, from, whofrom, 1)
#elif defined(NX)
      integer ctype
      integer infocount, infonode
      external infocount, infonode
c
      if (from .eq. -1) then
         ctype = type
      else
         ctype = type + from*32768
      endif
      call crecv(ctype, buf, buflen)
c
c     Note that if get an interrupt here these no.s will be wrong!
c
      msglen = infocount()
      whofrom= infonode()
#else
      call errquit('ga_rcv_msg: incorrect compilation flags', 0)
#endif
      end
#ifdef DATA_SERVER
      subroutine ga_server()
#else
      subroutine ga_server(msg, from)
#endif
      implicit none
#include "mafdecls.h"
#include "global.h"
#include "globalp.h"
#include "tcgmsg.h"
c
      integer msg(8)
      integer len
      integer from
      integer g_a
      integer ack
      integer value
      double precision crap
      integer ga_local_read_inc
      external ga_local_read_inc
c
#ifdef DATA_SERVER
 10   call ga_rcv_msg(GA_TYPE_REQ, msg, mitob(8), len, -1, from)
#endif
*      call masktrap(0)
*      write(6,1) me, msg
* 1    format(' request ', 9i5)
c
c     This is just to get around inability to flush the TCP/IP
c     message buffers when trying to sync ... make sender/receiver
c     be synched when the global data is being modified in MIMD mode
c
c     Actually this sync is now assumed by some of the buffer
c     usage so cannot simply remove this now.
c
*      if (msg(8) .ne. GA_OP_GET) then
         call ga_snd_msg(GA_TYPE_ACK, ack, mitob(1), from)
*      endif
c
      if (msg(8) .eq. GA_OP_GET) then
c
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1)
         if (len .gt. tmpsize)
     $        call errquit('ga_server: tmp too small', len)
         call ga_get_local(msg(1), msg(2), msg(3), msg(4),
     $        msg(5), tmp, 1, msg(3)-msg(2)+1)
         if (msg(7) .eq. MT_DBL) then
            call ga_snd_msg(GA_TYPE_GET, tmp, mdtob(len), from)
         else
            call ga_snd_msg(GA_TYPE_GET, tmp, mitob(len), from)
         endif
c
      else if (msg(8) .eq. GA_OP_PUT) then
c
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1)
         if (len .gt. tmpsize)
     $        call errquit('ga_server: tmp too small', len)
         call ga_rcv_msg(GA_TYPE_PUT, tmp, mdtob(tmpsize), len, from,
     $        from)
         call ga_put_local(msg(1), msg(2), msg(3), msg(4),
     $        msg(5), tmp, 1, msg(3)-msg(2)+1)
c
      else if (msg(8) .eq. GA_OP_ACC) then
c
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1) + 1
         if (len .gt. tmpsize)
     $        call errquit('ga_server: tmp too small', len)
         call ga_rcv_msg(GA_TYPE_ACC, tmp, mdtob(tmpsize), len, from,
     $        from)
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1) + 1
         call ga_acc_local(msg(1), msg(2), msg(3), msg(4),
     $        msg(5), tmp, msg(3)-msg(2)+1, tmp(len))
c
      else if (msg(8) .eq. GA_OP_IACC) then
c
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1) + 1
         if (len .gt. itmpsize)
     $        call errquit('ga_server: itmp too small', len)
         call ga_rcv_msg(GA_TYPE_IACC, itmp, mitob(itmpsize), len, from,
     $        from)
         len = (msg(3)-msg(2)+1)*(msg(5)-msg(4)+1) + 1
         call ga_iacc_local(msg(1), msg(2), msg(3), msg(4),
     $        msg(5), itmp, msg(3)-msg(2)+1, itmp(len))
c
      else if (msg(8) .eq. GA_OP_RDI) then
c
         value = ga_local_read_inc(msg(1), msg(2), msg(3), msg(4))
         call ga_snd_msg(GA_TYPE_RDI, value, mitob(1), from)
c
      else if (msg(8) .eq. GA_OP_DSC) then
c
         call ga_rcv_msg(GA_TYPE_DSC, tmp, mdtob(tmpsize), len, from,
     $        from)
         call ga_dscal(msg(1), tmp(1))
c
      else if (msg(8) .eq. GA_OP_COP) then
c
         call ga_copy(msg(1), msg(2))
c
      else if (msg(8) .eq. GA_OP_DCT) then
c
         if (msg(2).gt.tmpsize .or. msg(2).gt.itmpsize)
     $        call errquit('ga_server: dscatter overflows buffer')
         call ga_rcv_msg(GA_TYPE_DCV, tmp, mdtob(tmpsize), len, from,
     $        from)
         call ga_rcv_msg(GA_TYPE_DCI, itmp, mitob(itmpsize), len, from,
     $        from)
         call ga_rcv_msg(GA_TYPE_DCJ, jtmp, mitob(itmpsize), len, from,
     $        from)
         call ga_local_dscatter(msg(1), tmp, itmp, jtmp, msg(2))
c
      else if (msg(8) .eq. GA_OP_CRE) then
c
         if (.not. ga_create(msg(7), msg(2), msg(3), 'dummy',
     $        msg(4), msg(5), g_a))
     $        call errquit('ga_server: create failed', 0)
         if (g_a .ne. msg(1))
     $        call errquit('ga_server: g_a does not match', g_a)
c
      else if (msg(8) .eq. GA_OP_DES) then
c
         if (.not. ga_destroy(msg(1)))
     $        call errquit('ga_server: destroy failed', g_a)
c
      else if (msg(8) .eq. GA_OP_ZER) then
c
         call ga_zero(msg(1))
c
      else if (msg(8) .eq. GA_OP_DDT) then
c
         crap = ga_ddot(msg(1), msg(2))
c
      else if (msg(8) .eq. GA_OP_ADD) then
c
         call ga_rcv_msg(GA_TYPE_ADD, tmp, mdtob(tmpsize), len, from,
     $        from)
         call ga_dadd(tmp(1), msg(1), tmp(2), msg(2), msg(3))
c
      else if (msg(8) .eq. GA_OP_END) then
c
         call pend()
#ifdef AIX
         call exit(%val(0))
#else
         call exit(0)
#endif
c
      else
c
         call errquit('ga_server: unknown request', 0)
      endif
c
#ifdef DATA_SERVER
      goto 10
#endif
c
      end
      subroutine ga_sync()
      implicit none
#include "globalp.h"
#include "tcgmsg.h"
c
      integer ibuf, iproc, len, from
c
c     Synchronize the client/compute processes ... this is 
c     sufficient to ensure that any data handler processes 
c     are in a well defined state ... note that this is only 
c     true if we ensure that writes (i.e., put/acc) are
c     complete ... hence the explicit ack in ga_snd_request()
c
#if defined(DATA_SERVER)
      if (me .ge. nserver) then
c
c     Just in case some code sharing between data/compute servers
c     causes a data server to call ga_sync
c
         return
      else
c
c     Dumb synchronization ... all send to 0 then 0 responds
c
         if (me .gt. 0) then
            call ga_snd_msg(GA_TYPE_SYN, ibuf, mitob(1), 0)
            call ga_rcv_msg(GA_TYPE_SYN, ibuf, mitob(1), len, 0, from)
         else
            do iproc = 1, nserver-1
               call ga_rcv_msg(GA_TYPE_SYN, ibuf, mitob(1), len,
     $              iproc, from)
            enddo
            do iproc = 1, nserver-1
               call ga_snd_msg(GA_TYPE_SYN, ibuf, mitob(1), iproc)
            enddo
         endif
      endif
#elif defined(NX)
      call gsync()
#else
      call errquit('ga_sync: invalid compilation flags', 0)
#endif
c      
      end
      subroutine ga_terminate()
      implicit none
#include "globalp.h"
#include "tcgmsg.h"
c     
c     This routine called ONLY by compute processes
c
      call ga_sync()
c
#ifdef DATA_SERVER
      call ga_snd_req(0, 0, 0, 0, 0, 0, 0, GA_OP_END, me)
#endif
c
      end
      integer function ga_mask(newmask)
      integer newmask
c
c     Set the mask for the receipt of remote accesses to local data
c     returning the old value of the mask
c
c     newmask = 1 (disabled ... use to enter critical section)
c     newmask = 0 (enabled  ... use to exit  critical section)
c
#ifdef NX
      integer masktrap, mynode
      external masktrap, mynode
*
*     uncomment * stuff to trace mask status
*
*      integer current
*      data current /0/
*c
*      if (newmask.eq.1 .and. current.eq.0) then
*         write(6,*) mynode(), ' disabling trap '
*         call forflush(6)
*      endif
c
      ga_mask = masktrap(newmask)
c
*      if (newmask.eq.0 .and. current.eq.1) then
*         write(6,*) mynode(), ' enabling trap '
*         call forflush(6)
*      endif
*      current = newmask
#else
      ga_mask = 0
#endif
c
      end
      subroutine ga_initialize()
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "tcgmsg.h"
c     
c     In the data server test implementation the highest numbered half
c     of the processes are assumed to be data servers in 1-1
c     correspondence with the application processes.
c     
      nproc = nnodes()
      me    = nodeid()
#ifdef DATA_SERVER
      nserver = nproc/2
#else
      nserver = nproc
#endif
      if (nserver .gt. max_nproc)
     $     call errquit('ga_initialize: too many processes', 0)
      oserver = me .ge. (nproc - nserver)
c
#if defined(DATA_SERVER)
      if (oserver) call ga_server()
#elif defined(NX)
      call ga_init_handler()
#else
      call errquit('ga_initialize: incorrect compilation flags', 0)
#endif
c
      if (me .eq. 0) then
         write(6,1) nproc-nserver, nproc-1
 1       format(/'Global array server processes are ',i3,' to ',i3/)
      endif
c
      call ga_sync()
c
      end
      logical function ga_create(type, dim1, dim2, array_name,
     $     chunk1, chunk2, g_a)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "tcgmsg.h"
c
      character*(*) array_name
      integer type, dim1, dim2, chunk1, chunk2, g_a
c
      integer iproc, nchunk, ldim1, ldim2, lname, lga, lp, i, j
      character*256 form
      logical overbose
      integer lenstr, int
      double precision dsqrt, dfloat
      intrinsic dsqrt, dfloat, int
      external lenstr
      data overbose /.false./    ! Enables printing of distribution
c
c      array_name    - a unique character string [input]
c
c      type          - MA type [input]
c
c      dim1/2        - array(dim1,dim2) as in FORTRAN [input]
c
c      chunk1/2      - minimum size that dimensions should
c                      be chunked up into [input]
c                      setting chunk1=dim1 gives distribution by 
c                              vertical strips (chunk2 columns)
c                      setting chunk2=dim2 gives distribution by
c                              horizontal strips (chunk1 rows)
c                      Actual chunks will be modified so that
c                      they are at least the size of the minimum and
c                      each process has either zero or one chunk.
c
c                      Specifying chunk1/2 as <= 1 will cause that
c                      dimension to be distributed evenly.
c
c      g_a           - integer handle for future references [output]
c
c     Synchronize all processes before messing with data structures
c
*      call ga_sync()
c
      ga_create = .false.
c
      if (.not. (type.eq.MT_DBL .or. type.eq.MT_INT)) then
         write(6,*) ' ga_create: type not yet supported ', array_name
         return
      else if (dim1.le.0 .or. dim2.le.0) then
         write(6,*) ' ga_create: array dimension invalid ',array_name
         return
      else if (chunk1.gt.dim1 .or. chunk2.gt.dim2) then
         write(6,*) ' ga_create: array chunk sizes invalid ',array_name,
     $        chunk1, chunk2
         return
      endif
c
c     Get next free global_array handle
c
      do g_a = 1, max_global_array
         if (.not.actv(g_a)) goto 91
      enddo
      write(6,*) ' ga_create: too many arrays ', array_name
      return
 91   continue
c
#ifdef DATA_SERVER
c
c     In the data server implementation this info must be propagated to
c     the  data server process ... which basically just executes
c     this code all over again
c
      if (.not. oserver) then
         call ga_snd_req(g_a, dim1, dim2, chunk1, chunk2, me, type,
     $        GA_OP_CRE, me)
      endif
#endif
c
c     Stash the info
c
      name(g_a)   = array_name
      dims(1,g_a) = dim1
      dims(2,g_a) = dim2
      ttyp(g_a)   = type
c
c     Try to figure out an OK chunking ... want:
c        a) at most one chunk per processor
c        b) chunk dimensions should be >= user provided limits
c        c) chunks should be as square as possible (assumes starts square)
c        
      if (chunk1.le.1 .and. chunk2 .le. 1) then
         chnk(1,g_a) = max(1, dim1/int(dsqrt(dfloat(nserver))))
         chnk(2,g_a) = max(1, (dim1*dim2)/(nserver*chnk(1,g_a)))
      else if (chunk1.le.1) then
         chnk(1,g_a) = max(1, (dim1*dim2)/(nserver*chunk2))
         chnk(2,g_a) = chunk2
      else if (chunk2.le.1) then
         chnk(1,g_a) = chunk1
         chnk(2,g_a) = max(1, (dim1*dim2)/(nserver*chunk1))
      else
         chnk(1,g_a) = max(1,chunk1)
         chnk(2,g_a) = max(1,chunk2)
      endif
c
 10   continue
      nchunk = ((dim1-1)/chnk(1,g_a) + 1)*((dim2-1)/chnk(2,g_a) + 1)
      if (nchunk .gt. nserver) then
         if (chnk(1,g_a).eq.dim1 .and. chnk(2,g_a).eq.dim2)
     $        call errquit('ga_create: chunking failed !!', 0)
         if (chnk(1,g_a) .lt. dim1) then
            chnk(1,g_a) = chnk(1,g_a) + 1
         endif
         if (chnk(2,g_a) .lt. dim2) then
            chnk(2,g_a) = chnk(2,g_a) + 1
         endif
         goto 10
      endif
      pdim(1,g_a) = (dim1-1)/chnk(1,g_a) + 1
      pdim(2,g_a) = (dim2-1)/chnk(2,g_a) + 1
c
c     Initialize distributions to 0:-1 => a null do loop range
c
      call ifill(nserver*2, 0, mapc(1, 0, g_a), 2)
      call ifill(nserver*2, -1, mapc(2, 0, g_a), 2)
c
c     Now figure out which process has what
c
      iproc = 0
      do j = 1, dim2, chnk(2,g_a)
         do i = 1, dim1, chnk(1,g_a)
            mapc(1,iproc,g_a) = i
            mapc(2,iproc,g_a) = min(i+chnk(1,g_a)-1,dim1)
            mapc(3,iproc,g_a) = j
            mapc(4,iproc,g_a) = min(j+chnk(2,g_a)-1,dim2)
            iproc = iproc + 1
         enddo
      enddo
c
      if (iproc .ne. nchunk)
     $     call errquit('ga_create: iproc != nchunk', iproc)
c
#ifdef DATA_SERVER
      if (oserver) then
         iproc = me - nserver
      else
         iproc = me
      endif
#else
      iproc = me
#endif
c
c     Figure out exact size of chunk I (or my server) is holding
c
      ldim(1, g_a) = mapc(2,iproc,g_a) - mapc(1,iproc,g_a) + 1
      ldim(2, g_a) = mapc(4,iproc,g_a) - mapc(3,iproc,g_a) + 1
c
c     OK ... now each (server) process merely has to allocate its own
c     memory and we are in business
c     
      if (.not. oserver) then
         continue
      else if (ldim(1,g_a)*ldim(2,g_a) .eq. 0) then
         continue
      else if (.not. ma_alloc_get(type, ldim(1,g_a)*ldim(2,g_a),
     $     array_name, hand(g_a), indx(g_a))) then
         write(6,*) ' ga_create: failed to allocate memory',
     $        array_name, ldim(1,g_a), ldim(2,g_a)
         return
      else
c
c     Initialize the array to garbage 
c     
         if (type .eq. MT_DBL) then
            call dfill(ldim(1,g_a)*ldim(2,g_a), -1.0d+300, 
     $           dbl_mb(indx(g_a)), 1)
         else
            call ifill(ldim(1,g_a)*ldim(2,g_a), -2147483647, 
     $           int_mb(indx(g_a)), 1)
         endif
      endif
c
      if (me .eq. 0) then
         ldim1 = log10(dfloat(dim1)) + 1
         ldim2 = log10(dfloat(dim2)) + 1
         lga = log10(dfloat(g_a)) + 1
         lp = log10(dfloat(nproc)) + 1
         lname = lenstr(array_name)
         if (type .eq. MT_DBL) then
            write(form, 1) lname, ldim1, ldim2, lga
         else
            write(form, 2) lname, ldim1, ldim2, lga
         endif
c     format(' ga_create: "',a20,'"(',i5,',',i5,') has handle ',i2)
 1       format('('' ga_create: double precision "'',a',i4,',''"('',i',
     $        i4,','','',i',i4,','') has handle '',i',i4,')')
 2       format('('' ga_create: integer "'',a',i4,',''"('',i',i4,
     $        ','','',i',i4,','') has handle '',i',i4,')')
         write(6,*)
         write(6,form) array_name, dim1, dim2, g_a
c
         write(form,3) ldim1, ldim1, ldim2, ldim2, lp
c     format(1x,'(',3(i6,','),i6,') -> ',i3)
 3       format('(''     ('',i',i4,','':'',i',i4,','', '',i',i4,
     $        ','':'',i',i4,','') -> '',i',i4,')')
         if (overbose) then
            do iproc = 0,nserver-1
               write(6,form) (mapc(i,iproc,g_a),i=1,4),iproc
            enddo
         endif
         write(6,*)
      endif
c
      ga_create = .true.
      actv(g_a) = .true.
c
c     Synchronize right at the end to ensure no use of array until
c     all is complete
c
      call ga_sync()
c
c$$$      write(6,*) ' ttyp ', ttyp              
c$$$      write(6,*) ' dims ', dims
c$$$      write(6,*) ' ldim ', ldim              
c$$$      write(6,*) ' pdim ', pdim              
c$$$      write(6,*) ' chnk ', chnk              
c$$$      write(6,*) ' hand ', hand              
c$$$      write(6,*) ' indx ', indx              
c$$$      write(6,*) ' mapc ', mapc
c$$$      write(6,*) ' actv ', actv              
c$$$      write(6,*) ' name ', name         
c$$$      write(6,*) ' me   ', me                
c$$$      write(6,*) ' npro ', nproc             
c$$$      write(6,*) ' nser ', nserver           
c$$$      write(6,*) ' oser ', oserver           
c$$$      write(6,*) ' max_ ', max_global_array  
c$$$      write(6,*) ' tmps ', tmpsize           
c$$$      write(6,*) ' max_ ', max_nproc         
c
      end
      logical function ga_destroy(g_a)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "tcgmsg.h"
c
      integer g_a
c
      call ga_sync()
      ga_destroy = .false.
c
      call ga_check_handle(g_a, 'ga_destroy')
c
      actv(g_a) = .false.
c
      if (.not. oserver) then
         call ga_snd_req(g_a, 0, 0, 0, 0, 0, 0, GA_OP_DES, me)
         ga_destroy = .true.
      else if (ldim(1,g_a)*ldim(2,g_a) .eq. 0) then
         ga_destroy = .true.
      else if (.not. ma_free_heap(hand(g_a))) then
         write(6,*) ' ga_destroy: failed to free memory?', g_a
      else
         ga_destroy = .true.
      endif
c
      end
      subroutine ga_inquire(g_a, array_name, type, dim1, dim2)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, dim1, dim2, type
      character*(*) array_name
c      
c      g_a        - array handle [input]
c      array_name - name given to create [output]
c      type       - type given to create [output]
c      dim1/2     - global array dimensions [output]
c
      call ga_check_handle(g_a, 'ga_inquire')
      array_name = name(g_a)
      type       = ttyp(g_a)
      dim1       = dims(1,g_a)
      dim2       = dims(2,g_a)
c
      end
      subroutine ga_get(g_a, ilo, ihi, jlo, jhi, buf, ld)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, ilo, ihi, jlo, jhi, ld
      double precision buf(*)
c
      integer ip_lo, ip_hi, jp_lo, jp_hi, ip, jp, iproc
      integer ilo_get, ihi_get, jlo_get, jhi_get
      integer ilo_ugh, ihi_ugh, jlo_ugh, jhi_ugh, ilimit, jlimit
c
#ifdef GA_TRACE
      call trace_stime
#endif
      call ga_check_handle(g_a, 'ga_get')
      if (ilo.le.0 .or. ihi.gt.dims(1,g_a) .or.
     $         jlo.le.0 .or. jhi.gt.dims(2,g_a)) then
         call errquit(' ga_get: indices out of range ', g_a)
      endif
c
c     Map index ranges on to virtual processor array
c
      ip_lo = (ilo-1)/chnk(1,g_a)
      ip_hi = (ihi-1)/chnk(1,g_a)
      jp_lo = (jlo-1)/chnk(2,g_a)
      jp_hi = (jhi-1)/chnk(2,g_a)
c
c     Loop thru virtual processes that hold data
c
      do jp = jp_lo, jp_hi
         do ip = ip_lo, ip_hi
c
c     Currently the map from virtual processor array to real
c     processors is very simple and ignores topology
c
            iproc = ip + jp*pdim(1,g_a)
c
c     Figure out the range of data required from this processor
c
            ilo_get = max(ilo, mapc(1,iproc,g_a))
            ihi_get = min(ihi, mapc(2,iproc,g_a))
            jlo_get = max(jlo, mapc(3,iproc,g_a))
            jhi_get = min(jhi, mapc(4,iproc,g_a))
c
c     Actually get the data ... if have data servers it is always remote
c
            if (iproc.eq.me .and. oserver) then
               call ga_get_local(g_a, ilo_get, ihi_get, jlo_get,
     $              jhi_get, buf,
     $              ilo_get-ilo+1+(jlo_get-jlo)*ld, ld)
c     
            else
c
c     Process data in chunks defined by the available buffer space
c     for incoming/outgoing messages. Ugh, loops within loops within ...
c
               ilimit = min(tmpsize, ihi_get-ilo_get+1)
               jlimit = min(tmpsize/ilimit, jhi_get-jlo_get+1)
               do jlo_ugh = jlo_get, jhi_get, jlimit
                  jhi_ugh = min(jhi_get, jlo_ugh+jlimit-1)
                  do ilo_ugh = ilo_get, ihi_get, ilimit
                     ihi_ugh = min(ihi_get, ilo_ugh+ilimit-1)
                     call ga_get_remote(g_a, ilo_ugh, ihi_ugh,
     $                    jlo_ugh, jhi_ugh, buf,
     $                    ilo_ugh-ilo+1+(jlo_ugh-jlo)*ld, ld, iproc)
                  enddo
               enddo
            endif
         enddo
      enddo
c
#ifdef GA_TRACE
      call trace_etime
      call trace_genrec(g_a, ilo, ihi, jlo, jhi, GA_OP_GET)
#endif
c
      end
      subroutine ga_get_local(g_a, ilo, ihi, jlo, jhi, buf, bbase, ld)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
c
      integer g_a, ilo, ihi, jlo, jhi, bbase, ld
      double precision buf(*)
c
      integer gbase, iproc, oldmask
c
c     First do usual paranoia check on arguments and data structure
c
#ifdef DATA_SERVER
      iproc = me - nserver
#else
      iproc = me
#endif
c
      call ga_check_handle(g_a, 'ga_get_local')
      if (ilo.lt.mapc(1,iproc,g_a) .or.
     $     ihi.gt.mapc(2,iproc,g_a) .or.
     $     jlo.lt.mapc(3,iproc,g_a) .or.
     $     jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_get_local: local indices out of range ', g_a)
      else
c
c     All seems OK ... inside a critical section get the data
c
         oldmask = ga_mask(1)
         gbase = indx(g_a) + ilo - mapc(1,iproc,g_a) +
     $        (jlo-mapc(3,iproc,g_a))*ldim(1,g_a) 
         if (ttyp(g_a) .eq. MT_DBL) then
            call dbl_block_move(dbl_mb, gbase, ldim(1,g_a), buf, bbase,
     $           ld, ihi-ilo+1, jhi-jlo+1)
         else
            call int_block_move(int_mb, gbase, ldim(1,g_a), buf, bbase,
     $           ld, ihi-ilo+1, jhi-jlo+1)
         endif
         oldmask = ga_mask(oldmask)
      endif
c
      end
      subroutine ga_get_remote(g_a, ilo, ihi, jlo, jhi, buf, bbase,
     $     ld, iproc)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
#include "tcgmsg.h"
c
      integer g_a, ilo, ihi, jlo, jhi, bbase, ld, iproc
      double precision buf(*)
c
      integer len, from, ldtmp, to, oldmask, firstmask
c
c     First do usual paranoia check on arguments and data structure
c
      call ga_check_handle(g_a, 'ga_get_remote')
      if (iproc.lt.0 .or. iproc.ge.nserver) then
         call errquit(' ga_get_remote: iproc out of range ', iproc)
      else if (ilo.lt.mapc(1,iproc,g_a) .or.
     $         ihi.gt.mapc(2,iproc,g_a) .or.
     $         jlo.lt.mapc(3,iproc,g_a) .or.
     $         jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_get_remote: mapc violated ', g_a)
      else if ((ihi-ilo+1)*(jhi-jlo+1).gt.tmpsize) then
         call errquit(' ga_get_remote: internal buffer too small',
     $        (ihi-ilo+1)*(jhi-jlo+1))
      else
c
c     All seems OK ... do a remote request (breaking cycles)
c
         if (me .lt. iproc) firstmask = ga_mask(1)
         call ga_snd_req(g_a, ilo, ihi, jlo, jhi, me, ttyp(g_a),
     $        GA_OP_GET, iproc)
c
         ldtmp = ihi-ilo+1
c
c     Receive data and copy from tmp into final location
c     
         to = iproc
#ifdef DATA_SERVER
      to = to + nserver
#endif
c     
         oldmask = ga_mask(1)
         if (ttyp(g_a) .eq. MT_DBL) then
            call ga_rcv_msg(GA_TYPE_GET, tmp, mdtob(tmpsize), len, to,
     $           from)
            if (len .ne. mdtob((ihi-ilo+1)*(jhi-jlo+1)))
     $           call errquit('ga_get_remote: response wrong size', len)
            call dbl_block_move(tmp, 1, ldtmp, buf, bbase, ld,
     $           ihi-ilo+1, jhi-jlo+1)
         else
            call ga_rcv_msg(GA_TYPE_GET, tmp, mdtob(tmpsize), len, to,
     $           from)
            if (len .ne. mitob((ihi-ilo+1)*(jhi-jlo+1)))
     $           call errquit('ga_get_remote: response wrong size', len)
            call int_block_move(tmp, 1, ldtmp, buf, bbase, ld,
     $           ihi-ilo+1, jhi-jlo+1)
         endif
         oldmask = ga_mask(oldmask)
         if (me .lt. iproc) firstmask = ga_mask(firstmask)
c
      endif
c     
      end
      subroutine ga_put(g_a, ilo, ihi, jlo, jhi, buf, ld)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, ilo, ihi, jlo, jhi, ld
      double precision buf(*)
c
      integer ip_lo, ip_hi, jp_lo, jp_hi, ip, jp, iproc
      integer ilo_put, ihi_put, jlo_put, jhi_put
      integer ilo_ugh, ihi_ugh, jlo_ugh, jhi_ugh, ilimit, jlimit
c
#ifdef GA_TRACE
      call trace_stime
#endif
c
      call ga_check_handle(g_a, 'ga_put')
      if (ilo.le.0 .or. ihi.gt.dims(1,g_a) .or.
     $     jlo.le.0 .or. jhi.gt.dims(2,g_a)) then
         call errquit(' ga_put: indices out of range ', g_a)
      endif
c
c     Map index ranges on to virtual processor array
c
      ip_lo = (ilo-1)/chnk(1,g_a)
      ip_hi = (ihi-1)/chnk(1,g_a)
      jp_lo = (jlo-1)/chnk(2,g_a)
      jp_hi = (jhi-1)/chnk(2,g_a)
c
c     Loop thru virtual processes that hold data
c
      do jp = jp_lo, jp_hi
         do ip = ip_lo, ip_hi
c
c     Currently the map from virtual processor array to real
c     processors is very simple and ignores topology
c
            iproc = ip + jp*pdim(1,g_a)
c
c     Figure out the range of data required from this processor
c
            ilo_put = max(ilo, mapc(1,iproc,g_a))
            ihi_put = min(ihi, mapc(2,iproc,g_a))
            jlo_put = max(jlo, mapc(3,iproc,g_a))
            jhi_put = min(jhi, mapc(4,iproc,g_a))
c
c     Actually put the data 
c
            if (iproc .eq. me .and. oserver) then
               call ga_put_local(g_a, ilo_put, ihi_put, jlo_put,
     $              jhi_put, buf, 
     $              ilo_put-ilo+1+(jlo_put-jlo)*ld, ld)
            else
c
c     Process data in chunks defined by the available buffer space
c     for incoming/outgoing messages. Ugh, loops within loops within ...
c
               ilimit = min(tmpsize, ihi_put-ilo_put+1)
               jlimit = min(tmpsize/ilimit, jhi_put-jlo_put+1)
               do jlo_ugh = jlo_put, jhi_put, jlimit
                  jhi_ugh = min(jhi_put, jlo_ugh+jlimit-1)
                  do ilo_ugh = ilo_put, ihi_put, ilimit
                     ihi_ugh = min(ihi_put, ilo_ugh+ilimit-1)
                     call ga_put_remote(g_a, ilo_ugh, ihi_ugh,
     $                    jlo_ugh, jhi_ugh, buf,
     $                    ilo_ugh-ilo+1+(jlo_ugh-jlo)*ld, ld, iproc)
                  enddo
               enddo
            endif
         enddo
      enddo
c
#ifdef GA_TRACE
      call trace_etime
      call trace_genrec(g_a, ilo, ihi, jlo, jhi, GA_OP_PUT)
#endif
c
      end
      subroutine ga_put_local(g_a, ilo, ihi, jlo, jhi, buf, bbase, ld)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
c
      integer g_a, ilo, ihi, jlo, jhi, bbase, ld
      double precision buf(*)
c
      integer gbase, iproc, oldmask
c
c     First do usual paranoia check on arguments and data structure
c
#ifdef DATA_SERVER
      iproc = me - nserver
#else
      iproc = me
#endif
c
      call ga_check_handle(g_a, 'ga_put_local')
      if (ilo.lt.mapc(1,iproc,g_a) .or.
     $     ihi.gt.mapc(2,iproc,g_a) .or.
     $     jlo.lt.mapc(3,iproc,g_a) .or.
     $     jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_put_local: local indices out of range ', g_a)
      else if (ldim(1,g_a)*ldim(2,g_a).ne.0 .and. indx(g_a).eq.0) then
         call errquit(' ga_put_local: null pointer? ', g_a)
      else
c
c     All seems OK ... inside a critical section put the data
c
         oldmask = ga_mask(1)
         gbase = indx(g_a) + ilo - mapc(1,iproc,g_a) +
     $        (jlo-mapc(3,iproc,g_a))*ldim(1,g_a) 
c
*         write(6,*) ' ga_put: ilo, ihi, jlo, jhi ',
*     $        ilo, ihi, jlo, jhi
*         write(6,*) ' ld, gbase, ldim(1,g_a), ihi-ilo+1, jhi-jlo+1',
*     $        ld, gbase, ldim(1,g_a), ihi-ilo+1, jhi-jlo+1
*         call ffflush(6)
c
         if (ttyp(g_a) .eq. MT_DBL) then
            call dbl_block_move(buf, bbase, ld, dbl_mb, gbase,
     $           ldim(1,g_a), ihi-ilo+1, jhi-jlo+1)
         else
            call int_block_move(buf, bbase, ld, int_mb, gbase,
     $           ldim(1,g_a), ihi-ilo+1, jhi-jlo+1)
         endif
         oldmask = ga_mask(oldmask)
      endif
c
      end
      subroutine ga_put_remote(g_a, ilo, ihi, jlo, jhi, buf, bbase,
     $     ld, iproc)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
#include "tcgmsg.h"
c
      integer g_a, ilo, ihi, jlo, jhi, bbase, ld, iproc
      double precision buf(*)
c
      integer ldtmp, len, to, oldmask, firstmask
c
c     First do usual paranoia check on arguments and data structure
c
      call ga_check_handle(g_a, 'ga_put_remote')
      if (iproc.lt.0 .or. iproc.ge.nserver) then
         call errquit(' ga_put_remote: iproc out of range ', iproc)
      else if (ilo.lt.mapc(1,iproc,g_a) .or.
     $         ihi.gt.mapc(2,iproc,g_a) .or.
     $         jlo.lt.mapc(3,iproc,g_a) .or.
     $         jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_put_remote: invalid index range ', g_a)
      else if ((ihi-ilo+1)*(jhi-jlo+1).gt.tmpsize) then
         call errquit(' ga_put_remote: internal buffer too small',
     $        (ihi-ilo+1)*(jhi-jlo+1))
      else
c
c     All seems OK ... do a remote request (breaking cycles)
c
         if (me .lt. iproc) firstmask = ga_mask(1)
         call ga_snd_req(g_a, ilo, ihi, jlo, jhi, me, ttyp(g_a),
     $        GA_OP_PUT, iproc)
c
c     Copy data to temporary buffer (the buffer is static storage
c     so must be protected in a critical section ... can do this
c     without deadlock as are now in a dialogue with the remote process.
c     
         oldmask = ga_mask(1)
c
         ldtmp = ihi-ilo+1
         len = (ihi-ilo+1)*(jhi-jlo+1)
c
         to = iproc
#ifdef DATA_SERVER
         to = to + nserver
#endif
c
         if (ttyp(g_a) .eq. MT_DBL) then
            call dbl_block_move(buf, bbase, ld, tmp, 1, ldtmp, ldtmp,
     $           jhi-jlo+1)
            call ga_snd_msg(GA_TYPE_PUT, tmp, mdtob(len), to)
         else
            call int_block_move(buf, bbase, ld, tmp, 1, ldtmp, ldtmp,
     $           jhi-jlo+1)
            call ga_snd_msg(GA_TYPE_PUT, tmp, mitob(len), to)
         endif
c
c     End of critical section on buffer
c
         oldmask = ga_mask(oldmask)
c
c     This to undo breaking of cycles
c
         if (me .lt. iproc) firstmask = ga_mask(firstmask)
c
      endif
c     
      end
      subroutine ga_acc(g_a, ilo, ihi, jlo, jhi, buf, ld, alpha)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, ilo, ihi, jlo, jhi, ld
      double precision buf(1:ld, 1:*), alpha
c
      integer ip_lo, ip_hi, jp_lo, jp_hi, ip, jp, iproc
      integer ilo_acc, ihi_acc, jlo_acc, jhi_acc
      integer ilo_ugh, ihi_ugh, jlo_ugh, jhi_ugh, ilimit, jlimit
c
#ifdef GA_TRACE
      call trace_stime
#endif
c
      call ga_check_handle(g_a, 'ga_acc')
      if (ttyp(g_a) .ne. MT_DBL) then
         call errquit(' ga_acc: only supported for doubles', g_a)
      else if (ilo.le.0 .or. ihi.gt.dims(1,g_a) .or.
     $         jlo.le.0 .or. jhi.gt.dims(2,g_a)) then
         call errquit(' ga_acc: indices out of range ', g_a)
      endif
c
c     Map index ranges on to virtual processor array
c
      ip_lo = (ilo-1)/chnk(1,g_a)
      ip_hi = (ihi-1)/chnk(1,g_a)
      jp_lo = (jlo-1)/chnk(2,g_a)
      jp_hi = (jhi-1)/chnk(2,g_a)
c
c     Loop thru virtual processes that hold data
c
      do jp = jp_lo, jp_hi
         do ip = ip_lo, ip_hi
c
c     Currently the map from virtual processor array to real
c     processors is very simple and ignores topology
c
            iproc = ip + jp*pdim(1,g_a)
c
c     Figure out the range of data required from this processor
c
            ilo_acc = max(ilo, mapc(1,iproc,g_a))
            ihi_acc = min(ihi, mapc(2,iproc,g_a))
            jlo_acc = max(jlo, mapc(3,iproc,g_a))
            jhi_acc = min(jhi, mapc(4,iproc,g_a))
c
            if (iproc .eq. me .and. oserver) then
               call ga_acc_local(g_a, ilo_acc, ihi_acc, jlo_acc,
     $              jhi_acc, buf(ilo_acc-ilo+1,jlo_acc-jlo+1), ld,
     $              alpha)
            else
c
c     Process data in chunks defined by the available buffer space
c     for incoming/outgoing messages. Ugh, loops within loops within ...
c
               ilimit = min(tmpsize-1, ihi_acc-ilo_acc+1)
               jlimit = min((tmpsize-1)/ilimit, jhi_acc-jlo_acc+1)
               do jlo_ugh = jlo_acc, jhi_acc, jlimit
                  jhi_ugh = min(jhi_acc, jlo_ugh+jlimit-1)
                  do ilo_ugh = ilo_acc, ihi_acc, ilimit
                     ihi_ugh = min(ihi_acc, ilo_ugh+ilimit-1)
                     call ga_acc_remote(g_a, ilo_ugh, ihi_ugh, jlo_ugh,
     $                    jhi_ugh, buf(ilo_ugh-ilo+1,jlo_ugh-jlo+1), ld,
     $                    alpha, iproc)
                  enddo
               enddo
            endif
         enddo
      enddo
c
#ifdef GA_TRACE
      call trace_etime
      call trace_genrec(g_a, ilo, ihi, jlo, jhi, GA_OP_ACC)
#endif
c
      end
      subroutine ga_acc_local(g_a, ilo, ihi, jlo, jhi, buf, ld, alpha)
      implicit none
#include "mafdecls.h"
#include "global.h"
#include "globalp.h"
c
      integer g_a, ilo, ihi, jlo, jhi, ld
      double precision buf(1:ld, 1:*), alpha
c
      integer i, j, gbase, iproc, oldmask
c
c     First do usual paranoia check on arguments and data structure
c
#ifdef DATA_SERVER
      iproc = me - nserver
#else
      iproc = me
#endif
c
      call ga_check_handle(g_a, 'ga_acc_local')
      if (ilo.lt.mapc(1,iproc,g_a) .or.
     $         ihi.gt.mapc(2,iproc,g_a) .or.
     $         jlo.lt.mapc(3,iproc,g_a) .or.
     $         jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_acc_local: local indices out of range ', g_a)
      else if (ldim(1,g_a)*ldim(2,g_a).ne.0 .and. indx(g_a).eq.0) then
         call errquit(' ga_acc_local: null pointer? ', g_a)
      else
c
c     All seems OK ... inside a critical section acc the data
c
         oldmask = ga_mask(1)
         gbase = indx(g_a) - mapc(1,iproc,g_a) +
     $        (jlo-mapc(3,iproc,g_a))*ldim(1,g_a) 
         do j = jlo, jhi
            do i = ilo, ihi
               dbl_mb(gbase + i) = dbl_mb(gbase + i) +
     $              alpha*buf(i-ilo+1,j-jlo+1)
            enddo
            gbase = gbase + ldim(1,g_a)
         enddo
         oldmask = ga_mask(oldmask)
      endif
c
      end
      subroutine ga_acc_remote(g_a, ilo, ihi, jlo, jhi, buf, ld, alpha,
     $     iproc)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
#include "tcgmsg.h"
c
      integer g_a, ilo, ihi, jlo, jhi, ld, iproc
      double precision buf(1:ld, 1:*), alpha
c
      integer i, j, ldtmp, len, to, oldmask, firstmask
c
c     First do usual paranoia check on arguments and data structure
c
      call ga_check_handle(g_a, 'ga_acc_remote')
      if (iproc.lt.0 .or. iproc.ge.nserver) then
         call errquit(' ga_acc_remote: iproc out of range ', iproc)
      else if (ilo.lt.mapc(1,iproc,g_a) .or.
     $         ihi.gt.mapc(2,iproc,g_a) .or.
     $         jlo.lt.mapc(3,iproc,g_a) .or.
     $         jhi.gt.mapc(4,iproc,g_a)) then
         call errquit(' ga_acc_remote: invalid index range ', g_a)
      else if ((ihi-ilo+1)*(jhi-jlo+1)+1.gt.tmpsize) then
         call errquit(' ga_acc_remote: internal buffer too small',
     $        (ihi-ilo+1)*(jhi-jlo+1))
      else
c
c     All seems OK ... do a remote request (breaking cycles)
c
         if (me .lt. iproc) firstmask = ga_mask(1)
         call ga_snd_req(g_a, ilo, ihi, jlo, jhi, me, ttyp(g_a),
     $        GA_OP_ACC, iproc)
c
c     Copy data to temporary buffer (don't forget alpha)
c     
         oldmask = ga_mask(1)
         ldtmp = ihi-ilo+1
         do j = jlo, jhi
            do i = ilo, ihi
               tmp(i-ilo+1 + (j-jlo)*ldtmp) = buf(i-ilo+1,j-jlo+1) 
            enddo
         enddo
         len = (ihi-ilo+1)*(jhi-jlo+1) + 1
         tmp(len) = alpha
c
         to = iproc
#ifdef DATA_SERVER
         to = to + nserver
#endif
         call ga_snd_msg(GA_TYPE_ACC, tmp, mdtob(len), to)
c
         oldmask = ga_mask(oldmask)
         if (me .lt. iproc) firstmask = ga_mask(firstmask)
c
      endif
c     
      end
      subroutine dbl_block_move(a, abase, ald, b, bbase, bld, ni, nj)
      implicit none
      double precision a(*), b(*)
      integer abase, bbase, ald, bld, ni, nj
c
c     a(1:ni,1:nj) -> b(1:ni,1:nj) where ald, bld are the leading
c     dimensions of a, b respectively and abase, bbase are the offsets
c     in the respective arrays (as linear entities) to the first word
c     to be copied.
c
c     This routine is necessary as one cannot cast pointers in FORTRAN
c     so all address arithmetic must be deferred until U are in a routine
c     with the arrays correctly typed (of course it violates the FORTRAN
c     standard to not match the type of formal and actual arguments
c     but it does work ... at least so far)
c
      integer i, j, aoff, boff
c
      aoff = abase
      boff = bbase
      do j = 0, nj-1
         do i = 0, ni-1
            b(boff+i) = a(aoff+i)
         enddo
         aoff = aoff + ald
         boff = boff + bld
      enddo
c
      end
      subroutine int_block_move(a, abase, ald, b, bbase, bld, ni, nj)
      implicit none
      integer a(*), b(*)
      integer abase, bbase, ald, bld, ni, nj
c
c     a(1:ni,1:nj) -> b(1:ni,1:nj) where ald, bld are the leading
c     dimensions of a, b respectively and abase, bbase are the offsets
c     in the respective arrays (as linear entities) to the first word
c     to be copied.
c
c     This routine is necessary as one cannot cast pointers in FORTRAN
c     so all address arithmetic must be deferred until U are in a routine
c     with the arrays correctly typed (of course it violates the FORTRAN
c     standard to not match the type of formal and actual arguments
c     but it does work ... at least so far)
c
      integer i, j, aoff, boff
c
      aoff = abase
      boff = bbase
      do j = 0, nj-1
         do i = 0, ni-1
            b(boff+i) = a(aoff+i)
         enddo
         aoff = aoff + ald
         boff = boff + bld
      enddo
c
      end
      subroutine ga_distribution(g_a, iproc, ilo, ihi, jlo, jhi,
     $     ma_index)   
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, iproc, ilo, ihi, jlo, jhi, ma_index
      integer node
c
c      g_a             - array handle [input]
c      iproc           - process number [input]
c      ilo/ihi/jlo/jhi - range held by process iproc [output]
c      ma_index        - if (iproc == this process) returns
c                        MA index in appropriately typed base array 
c                        of the data
c
      node = iproc
#ifdef DATA_SERVER
      if (node .ge. nserver) node = node - nserver
#endif
      call ga_check_handle(g_a, 'ga_distribution')
      if (iproc.lt. 0 .or. iproc.ge.nproc) then
         call errquit(' ga_distribution: iproc invalid ', iproc)
      else
         ilo = mapc(1, node, g_a)
         ihi = mapc(2, node, g_a)
         jlo = mapc(3, node, g_a)
         jhi = mapc(4, node, g_a)
c
         if (iproc .eq. me) then
            ma_index = indx(g_a)
         else
            ma_index = 0
         endif
      endif
c
      end
      subroutine ga_check_handle(g_a, string)
#include "mafdecls.h"
#include "globalp.h"
#include "tcgmsg.h"
c
      integer g_a
      character *(*) string
c
c     Check that the global array handle g_a is valid ... if not
c     call errquit with the string provided
c
      if (g_a.le.0 .or. g_a.gt.max_global_array) then
         write(6,*) ' ga_check_handle: ', string
         call errquit(' invalid global array handle ', g_a)
      else if (.not. actv(g_a)) then
         write(6,*) ' ga_check_handle: ', string
         call errquit(' global array is inactive ',  g_a)
      endif
c
      end
      integer function ga_nnodes()
      implicit none
c
c     Return no. of compute processes
c
      integer nproc
#ifdef TCGMSG
      integer nnodes
      external nnodes
      nproc = nnodes()
#elif defined(NX)
      integer numnodes
      external numnodes
      nproc = numnodes()
#else
      call errquit('ga_nnodes: invalid compiliation flags',0)
#endif
c
#ifdef DATA_SERVER
      if (mod(nproc,2).ne.0) 
     $    call errquit('ga_nnodes: must have even no. of processes',0)
      ga_nnodes = nproc/2
#else
      ga_nnodes = nproc
#endif
c
      end
      integer function ga_nodeid()
      implicit none
c
c     Return id of compute process =  0, ..., ga_nnodes()-1
c
#ifdef TCGMSG
      integer nodeid
      external nodeid
      ga_nodeid = nodeid()
#elif defined(NX)
      integer mynode
      external mynode
      ga_nodeid = mynode()
#else
      call errquit('ga_nodeid: invalid compiliation flags',0)
#endif
c
      end
      integer function ga_id_to_msg_id(node)
      integer node
c
c     Map from GA compute process ids to message passing process ids
c
      ga_id_to_msg_id = node
c
      end
      logical function ga_locate(g_a, i, j, owner)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, i, j, owner
      integer p, q            ! Map to virtual processor array
c
c     Return the logical compute process id that 'owns' i,j
c
      if (i.le.0 .or. i.gt.dims(1,g_a) .or.
     $    j.le.0 .or. j.gt.dims(2,g_a)) then
         ga_locate = .false.
         owner = -1
      else
         p = (i-1)/chnk(1,g_a)
         q = (j-1)/chnk(2,g_a)
         owner = p + q*pdim(1,g_a)
         ga_locate = .true.
      endif
c
      end
      subroutine ga_dscatter(g_a, v, i, j, nv)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
#include "global.h"
c     
      integer g_a
      integer nv                 ! No. of elements to scatter
      double precision v(nv)     ! Values to scatter
      integer i(nv), j(nv)       ! v(k) -> g_a(i(k),j(k))
c
      integer l_p, k_p           ! MA handle/index for process list
      integer loop, nelem, p, first, limit
c
c     Scatter elements of v into the global array
c     NOTE: the arrays v, i, j, are returned with values intact
c           but with their order shuffled
c
      if (nv .le. 0) return
#ifdef GA_TRACE
      call trace_stime
#endif
c
c     Error checking
c
      call ga_check_handle(g_a, 'ga_dscatter')
      if (ttyp(g_a) .ne. MT_DBL) 
     $     call errquit('ga_dscatter: must be double', g_a)
c
c     Allocate and generate list of owning processors
c
      if (.not. ma_push_get(MT_INT, nv, 'ga_dscatter', l_p, k_p))
     $     call errquit('ga_dscatter: failed to allocate p', nv)
c
      do loop = 1,nv
         if (.not. ga_locate(g_a, i(loop), j(loop), int_mb(k_p+loop-1)))
     $        call errquit('ga_dscatter: invalid i/j',
     $        i(loop)*100000 + j(loop))
      enddo
c
c     Sort the entries by processor
c
      call ga_sort_scat2(nv, v, i, j, int_mb(k_p))	
c
c     Limit messages to available buffer size
c
      limit = min(itmpsize, tmpsize)
c
c     Loop thru array sending elements to each processor in turn
c
      nelem = 0
      first = 0
      p = -1
      do loop = 1, nv
         if (int_mb(k_p+loop-1).ne.p .or. nelem.eq.limit) then
c
c     New processor encountered, send last batch
c
            if (nelem.gt.0 .and. p.eq.me .and. oserver) then
               call ga_local_dscatter(
     $              g_a, v(first), i(first), j(first), nelem)
            else if (nelem.gt.0) then
               call ga_remote_dscatter(
     $              g_a, v(first), i(first), j(first), nelem, p)
            endif
            first = loop
            nelem = 1
            p = int_mb(k_p+loop-1)
         else
            nelem = nelem + 1
         endif
      enddo
      if (nelem.gt.0 .and. p.eq.me .and. oserver) then
         call ga_local_dscatter(
     $        g_a, v(first), i(first), j(first), nelem)
      else if (nelem.gt.0) then
         call ga_remote_dscatter(
     $        g_a, v(first), i(first), j(first), nelem, p)
      endif
c
      if(.not. ma_pop_stack(l_p))
     $     call errquit('ga_dscatter: pop stack failed!', g_a)
c
#ifdef GA_TRACE
      call trace_etime
      call trace_genrec(g_a, 0, 0, 0, 0, GA_OP_DCT)
#endif
c
      end
      subroutine ga_remote_dscatter(g_a, v, i, j, nv, p)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c
      integer g_a
      integer nv                 ! No. of elements to scatter
      double precision v(nv)     ! Values to scatter
      integer i(nv), j(nv)       ! v(k) -> g_a(i(k),j(k))
      integer p                  ! Compute process that 'owns' data
c
      integer node               ! Actual id that owns the data
      integer oldmask
#include "global.h"
c
#ifdef DATA_SERVER
      node = p + nserver
#else
      node = p
#endif
c
      if (me .lt. p) oldmask = ga_mask(1)
c
      call ga_snd_req(g_a, nv, 0, 0, 0, 0, 0, GA_OP_DCT, p)
      call ga_snd_msg(GA_TYPE_DCV, v, mdtob(nv), node)
      call ga_snd_msg(GA_TYPE_DCI, i, mitob(nv), node)
      call ga_snd_msg(GA_TYPE_DCJ, j, mitob(nv), node)
c
      if (me .lt. p) oldmask = ga_mask(oldmask)
c
      end
      subroutine ga_local_dscatter(g_a, v, i, j, nv)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a
      integer nv                 ! No. of elements to scatter
      double precision v(nv)     ! Values to scatter
      integer i(nv), j(nv)       ! v(k) -> g_a(i(k),j(k))
c
c     Scatter elements into local piece of g_a
c
      integer k, ij, base, ilo, jlo, idim, oldmask, iproc
#include "global.h"
c
#ifdef DATA_SERVER
      iproc = me - nserver
#else
      iproc = me
#endif
      base = indx(g_a)
      ilo  = mapc(1,iproc,g_a)
      jlo  = mapc(3,iproc,g_a)
      idim = ldim(1,g_a)
c
      oldmask = ga_mask(1)
      do k = 1, nv
         ij = base + (i(k)-ilo) + (j(k)-jlo)*idim
         dbl_mb(ij) = v(k)
      enddo
      oldmask = ga_mask(oldmask)
c
      end
      subroutine ga_sort_scat(nv, v, i, j, p)	
      implicit none
      integer nv, i(nv), j(nv), p(nv)
      double precision v(nv)
c     
      integer k, l
c
c     Sort entries, grouping them by processor label
c
c     This routine is superceded by ga_sort_scat2 (hsort.scat.c)
c     but this will still function.
c
      do k = 1, nv
         do l = k+1, nv
            if (p(l) .lt. p(k))
     $           call ga_swap(v, i, j, p, k, l)
         enddo
      enddo
c
      end
      subroutine ga_swap(v, i, j, p, k, l)
      implicit none
      integer i(*), j(*), p(*), k, l, itmp
      double precision v(*), dtmp
c
c     Only used by ga_sort_scat ... ga_sort_scat2 has 
c     this function manually inlined.
c
      dtmp = v(k)
      v(k) = v(l)
      v(l) = dtmp
      itmp = i(k)
      i(k) = i(l)
      i(l) = itmp
      itmp = j(k)
      j(k) = j(l)
      j(l) = itmp
      itmp = p(k)
      p(k) = p(l)
      p(l) = itmp
c
      end
      integer function ga_read_inc(g_a, i, j, inc)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
c     
      integer g_a               ! GA handle
      integer i, j              ! Indices of array element
      integer inc               ! Increment
      integer p                 ! Owning process
      logical ga_locate
      external ga_locate
      integer ga_local_read_inc, ga_remote_read_inc
      external ga_local_read_inc, ga_remote_read_inc
c
c     Atomically read and increment the integer array element g_a(i,j)
c
c     *BEGIN CRITICAL SECTION*
c     return value = a(i,j)
c     a(i,j) += inc
c     *END CRITICAL SECTION*
c
#ifdef GA_TRACE
      call trace_stime
#endif
c
c     Error checking
c
      call ga_check_handle(g_a, 'ga_read_inc')
      if (ttyp(g_a) .ne. MT_INT) 
     $     call errquit('ga_read_inc: must be integer', g_a)
c
c     Figure out who owns the element and act accordingly
c
      if (.not. ga_locate(g_a, i, j, p))
     $     call errquit('ga_read_inc: i/j out of bounds', i*10000+j)
      if (p .eq. me .and. oserver) then
         ga_read_inc = ga_local_read_inc(g_a, i, j, inc)
      else
         ga_read_inc = ga_remote_read_inc(g_a, i, j, inc, p)
      endif
c
#ifdef GA_TRACE
      call trace_etime
      call trace_genrec(g_a, 0, 0, 0, 0, GA_OP_RDI)
#endif
c
      end
      integer function ga_remote_read_inc(g_a, i, j, inc, p)
      implicit none
#include "mafdecls.h"
#include "tcgmsg.h"
#include "globalp.h"
#include "global.h"
c
      integer g_a
      integer i, j, inc, p
      integer node, oldmask, value, len, from
c
#ifdef DATA_SERVER
      node = p + nserver
#else
      node = p
#endif
c
      if (me .lt. p) oldmask = ga_mask(1)
c
      call ga_snd_req(g_a, i, j, inc, 0, 0, 0, GA_OP_RDI, p)
      call ga_rcv_msg(GA_TYPE_RDI, value, mitob(1), len, node, from)
      ga_remote_read_inc = value
c
      if (me .lt. p) oldmask = ga_mask(oldmask)
c
      end
      integer function ga_local_read_inc(g_a, i, j, inc)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
#include "global.h"
c
      integer g_a
      integer i, j, inc, iproc, base, ilo, jlo, idim, ij, oldmask
c
#ifdef DATA_SERVER
      iproc = me - nserver
#else
      iproc = me
#endif
      base = indx(g_a)
      ilo  = mapc(1,iproc,g_a)
      jlo  = mapc(3,iproc,g_a)
      idim = ldim(1,g_a)
      ij   = base + (i-ilo) + (j-jlo)*idim
c
      oldmask = ga_mask(1)
      ga_local_read_inc = int_mb(ij)
      int_mb(ij) = int_mb(ij) + inc
      oldmask = ga_mask(oldmask)
c
      end
