      subroutine ga_add(alpha, g_a, beta, g_b, g_c)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, g_b, g_c
      integer abase, bbase, cbase, i, j, ij
      double precision alpha, beta
c
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit('ga_add: invalid array handle a', g_a)
      else if (g_b.le.0 .or. g_b.gt.n_global_array) then
         call errquit('ga_add: invalid array handle c', g_b)
      else if (g_c.le.0 .or. g_c.gt.n_global_array) then
         call errquit('ga_add: invalid array handle c', g_c)
      else if (.not. ma_get_index(hand(g_a), abase)) then
         call errquit('ga_add: unable to map array handle ?', g_a)
      else if (.not. ma_get_index(hand(g_b), bbase)) then
         call errquit('ga_add: unable to map array handle ?', g_b)
      else if (.not. ma_get_index(hand(g_c), cbase)) then
         call errquit('ga_add: unable to map array handle ?', g_c)
      else if (dims(1,g_a).ne.dims(1,g_b) .or.
     $         dims(1,g_a).ne.dims(1,g_c) .or.
     $         dims(2,g_a).ne.dims(2,g_c) .or.
     $         dims(2,g_a).ne.dims(2,g_b)) then
         call errquit('ga_add: dimensions do not match', 0)
      else
         do j = 1, dims(2,g_a)
            do i = 1, dims(1,g_a)
               ij = i-1 + (j-1)*dims(1,g_a)
               dbl_mb(cbase+ij) = alpha * dbl_mb(abase+ij) +
     $              beta * dbl_mb(bbase+ij)
            enddo
         enddo
      endif
c
      end
