      logical function ga_create(type, dim1, dim2, array_name,
     $     chunksize1, chunksize2, g_a)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      character*(*) array_name
      integer type, dim1, dim2, chunksize1, chunksize2, g_a, handle
c
c      array_name   - a unique character string [input]
c      type         - MA type [input]
c      dim1/2       - array(dim1,dim2) as in FORTRAN [input]
c      chunksize1/2 - min. size of blocks for dim1/2 [input]
c      g_a       - integer handle for future references
c
      if (type .ne. MT_DBL) then
         write(6,*) ' ga_create: type not yet supported ', array_name
         ga_create = .false.
         g_a = -1
      else if (n_global_array .eq. max_global_array) then
         write(6,*) ' ga_create: too many arrays ', array_name
         ga_create = .false.
         g_a = -1
      else if (dim1 .le. 0 .or. dim2 .le. 0) then
         write(6,*) ' ga_create: array dimension is invalid ',array_name
         ga_create = .false.
         g_a = -1
      else if (.not. ma_allocate_heap(MT_DBL, dim1*dim2, array_name, 
     $        handle)) then
c
c     allocation can also be on the stack as create/destroy is sychronous
c
         write(6,*) ' failed to allocate memory for ', array_name
         ga_create = .false.
         g_a = -1
      else
         n_global_array = n_global_array + 1
         name(n_global_array)   = array_name
         dims(1,n_global_array) = dim1
         dims(2,n_global_array) = dim2
         dist(n_global_array)   = 'BLOCK'
         ttyp(n_global_array)   = type
         actv(n_global_array)   = .true.
         chnk(1,n_global_array)   = chunksize1
         chnk(2,n_global_array)   = chunksize2
         hand(n_global_array)   = handle
         write(6,1) array_name, dim1, dim2, n_global_array
 1       format(' ga_create: "',a20,'"(',i5,',',i5,') has handle ',i2)
         ga_create = .true.
         g_a = n_global_array
      endif
c
      end
