      subroutine ga_dgemm(transa, transb, m, n, k, alpha, g_a,
     $        g_b, beta, g_c)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
      character*1 transa, transb
      integer m, n, k
      integer g_a, g_b, g_c
      double precision alpha, beta
c
c     c = alpha * a * b + beata c
c
      integer abase, bbase, cbase
c
c     Solve the generalized eigen-value problem returning
c     all eigen-vectors and values in ascending order
c
c     The input matrices may be destroyed
c
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit('ga_dgemm: invalid array handle for a', g_a)
      else if (.not. ma_get_index(hand(g_a), abase)) then
         call errquit('ga_dgemm: unable to map array handle a?', g_a)
      endif
      if (g_b.le.0 .or. g_b.gt.n_global_array) then
         call errquit('ga_dgemm: invalid array handle for a', g_b)
      else if (.not. ma_get_index(hand(g_b), bbase)) then
         call errquit('ga_dgemm: unable to map array handle a?', g_b)
      endif
      if (g_c.le.0 .or. g_c.gt.n_global_array) then
         call errquit('ga_dgemm: invalid array handle for a', g_c)
      else if (.not. ma_get_index(hand(g_c), cbase)) then
         call errquit('ga_dgemm: unable to map array handle a?', g_c)
      endif
c
      call dgemm(transa, transb, m, n, k, alpha, dbl_mb(abase),
     $     dims(1,g_a), dbl_mb(bbase), dims(1,g_b), beta, dbl_mb(cbase),
     $     dims(1,g_c))
c
      end
