      subroutine ga_diag(g_a, g_s, g_v, evals)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
      integer g_a               ! Matrix to diagonalize
      integer g_s               ! Metric
      integer g_v               ! Global matrix to return evecs
      double precision evals(*) ! Local array to return evals
c
      integer abase, sbase, vbase, l_fv1, l_fv2, k_fv1, k_fv2, ierr
      logical status
c
c     Solve the generalized eigen-value problem returning
c     all eigen-vectors and values in ascending order
c
c     The input matrices may be destroyed
c
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit('ga_diag: invalid array handle for a', g_a)
      else if (.not. ma_get_index(hand(g_a), abase)) then
         call errquit('ga_diag: unable to map array handle a?', g_a)
      else if (dims(1,g_a) .ne. dims(2,g_a)) then
         call errquit('ga_diag: can only diag square matrix', 0)
      endif
      if (g_s.le.0 .or. g_s.gt.n_global_array) then
         call errquit('ga_diag: invalid array handle for s', g_s)
      else if (.not. ma_get_index(hand(g_s), sbase)) then
         call errquit('ga_diag: unable to map array handle s ?', g_s)
      else if (dims(1,g_s) .ne. dims(2,g_s)) then
         call errquit('ga_diag: can only diag square matrix', 0)
      endif
      if (g_v.le.0 .or. g_v.gt.n_global_array) then
         call errquit('ga_diag: invalid array handle for v', g_v)
      else if (.not. ma_get_index(hand(g_v), vbase)) then
         call errquit('ga_diag: unable to map array handle v ?', g_v)
      else if (dims(1,g_v) .ne. dims(2,g_v)) then
         call errquit('ga_diag: can only diag square matrix', 0)
      endif
c
*      call ga_print(g_a)
*      call ga_print(g_s)
c
c     allocate scratch space
c
      status = ma_push_get(MT_DBL, dims(1,g_a), 'fv1', l_fv1, k_fv1)
      status = ma_push_get(MT_DBL, dims(1,g_a), 'fv2', l_fv2, k_fv2)
c
      call rsg(dims(1,g_a), dims(1,g_a), dbl_mb(abase), dbl_mb(sbase),
     $     evals, 1, dbl_mb(vbase), dbl_mb(k_fv1), dbl_mb(k_fv2), ierr)
c
*      call ga_print(g_v)
*      write(6,*) ' evals '
*      call output(evals, 1, dims(1,g_a), 1, 1, dims(1,g_a), 1, 1)
c
      status = ma_pop_stack(l_fv2)
      status = ma_pop_stack(l_fv1)
c
      end
