      subroutine ga_distribution(g_a, iproc, ilo, ihi, jlo, jhi,
     $     ma_index)   
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, iproc, ilo, ihi, jlo, jhi, ma_index
c
c      g_a             - array handle [input]
c      iproc           - process number [input]
c      ilo/ihi/jlo/jhi - range held by process iproc [output]
c      ma_index        - if (iproc == this process) returns
c                        MA index in appropriately typed base array 
c                        of the data
c
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit(' ga_distribution: invalid array handle ', g_a)
      else if (iproc .ne. 0) then
         call errquit(' ga_distribution: iproc is not zero ', iproc)
      else if (.not. ma_get_index(hand(g_a), ma_index)) then
         call errquit(' ga_distribution: unable to map array handle ?',
     $        g_a)
      else
         ilo = 1
         jlo = 1
         ihi = dims(1,g_a)
         jhi = dims(2,g_a)
      endif
c
      end
