      subroutine ga_symmetrize(g_a)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
      integer g_a               ! Matrix to symmetrize
c
      integer abase, i, j
      double precision tmp
c
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit('ga_sym: invalid array handle for a', g_a)
      else if (.not. ma_get_index(hand(g_a), abase)) then
         call errquit('ga_sym: unable to map array handle a?', g_a)
      else if (dims(1,g_a) .ne. dims(2,g_a)) then
         call errquit('ga_sym: can only sym square matrix', 0)
      endif
      do i = 1, dims(1,g_a)
         do j = 1, i-1
            tmp = (dbl_mb(abase-1+i+(j-1)*dims(1,g_a)) +
     $           dbl_mb(abase-1+j+(i-1)*dims(1,g_a))) * 0.5d0
            dbl_mb(abase-1+i+(j-1)*dims(1,g_a)) = tmp
            dbl_mb(abase-1+j+(i-1)*dims(1,g_a)) = tmp
         enddo
      enddo
c     
      end
