      double precision function ga_trace(g_a, g_b)
      implicit none
#include "mafdecls.h"
#include "globalp.h"
c
      integer g_a, g_b
      integer abase, bbase
      double precision ddot
      external ddot
c
      ga_trace = 0.0d0
      if (g_a.le.0 .or. g_a.gt.n_global_array) then
         call errquit('ga_trace: invalid array handle ', g_a)
      else if (g_b.le.0 .or. g_b.gt.n_global_array) then
         call errquit('ga_trace: invalid array handle ', g_b)
      else if (.not. ma_get_index(hand(g_a), abase)) then
         call errquit('ga_trace: unable to map array handle ?', g_a)
      else if (.not. ma_get_index(hand(g_b), bbase)) then
         call errquit('ga_trace: unable to map array handle ?', g_b)
      else if (dims(1,g_a).ne.dims(1,g_b) .or.
     $         dims(2,g_a).ne.dims(2,g_b)) then
         call errquit('ga_trace: dimensions do not match', 0)
      else
         ga_trace = ddot(dims(1,g_a)*dims(2,g_a),
     $        dbl_mb(abase), 1, dbl_mb(bbase), 1)
      endif
c
      end
