      subroutine gto_info(basis, NAtoms, nsh, nbfunc, np, max_prim,
     $     max_l, max_sh_bf, max_at_bf)
      implicit none
      integer basis, NAtoms, nsh, nbfunc, np, max_prim, max_l,
     $   max_sh_bf, max_at_bf
#include "int.h"
#include "mafdecls.h"
c
      integer iat, ibflo, ibfhi, ish
c
c     Return important dimension information about this basis set
c
c     NAtoms     ... no. of atoms on which functions are placed
c     nsh        ... no. of shells in the basis
c     nbfunc     ... no. of functions in the basis
c     np         ... no. of primitive functions in the basis
c     max_prim   ... maximum no. of primitives in any contraction
c     max_l      ... maximum angular momentum of any shell
c     max_sh_bf  ... maximum no. of functions in any shell
c     max_at_bf  ... maximum no. of functions on any atom
c
      NAtoms = NAt
      nsh = nshell
      nbfunc = 9999999
      np = 9999999              ! Unknown and uneeded for now
      max_prim = 9999999
      max_l = 9999999
c
      max_at_bf = 0
      do iat = 1, natoms
         call gto_at_to_bf(basis, iat, ibflo, ibfhi)
         max_at_bf = max(max_at_bf, ibfhi-ibflo+1)
      enddo
c
      max_sh_bf = 0
      do ish = 1, nshell
         call gto_sh_to_bf(basis, ish, ibflo, ibfhi)
         max_sh_bf = max(max_sh_bf, ibfhi-ibflo+1)
      enddo
c
      end
