C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     mk_gto_maps -- Make some extra maps comparable to RJHs GTO routines
C
C SYNOPSIS
      Subroutine Mk_GTO_Maps( IntEnv )
      Implicit NONE
      Integer IntEnv
C
C ARGUMENTS
C DESCRIPTION
C REVISION
C     $Id: mk_gto_maps.F,v 1.1 1993/11/08 19:49:12 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "integral_memory.fh"
#include "int.h"
#include "mafdecls.h"
C LOCAL VARIABLES
      Logical LResult
      Integer IAtom, IShell, LenLast
c$$$C
c$$$      Integer KS_Ind, NMS_Ind, KTop_Ind
C
C     Allocate for the additional arrays
C
      LResult = MA_Alloc_Get( MT_Int, NAt, 'KS array',
     $   Int_KS_Hdl, K_KS)
      LResult = MA_Alloc_Get( MT_Int, NAt, 'NMS array',
     $   Int_NMS_Hdl, K_NMS)
      LResult = MA_Alloc_Get( MT_Int, NShell, 'KTop array',
     $   Int_KTop_Hdl, K_KTop)
C
C     KTop -- Last basis function in shell
C     KS   -- First shell on atom
C
      iatom = 0
      do ishell = 1, nshell-1
         Int_MB(K_ktop-1+ishell) = KLoc(ishell+1) - 1
c
         if (iatom .ne. katom(ishell)) then
            iatom = iatom + 1
            Int_MB(K_ks+iatom-1) = ishell
         endif
      enddo
C
C     For the last one, we must compute the length of the last shell
C
      LenLast = KType(NShell) * (KType(NShell) + 1) / 2
      Int_MB(K_ktop-1+nshell) = Int_MB(K_KTop-1+NShell-1) + LenLast
C
C     NMS -- Number of shells on atom
C
      do iatom = 1, NAt-1
         Int_MB(K_nms+iatom-1) = Int_MB(K_ks+iatom) -
     $        Int_MB(K_ks+iatom-1)
      enddo
C
      Int_MB(K_nms+NAt-1) = nshell - Int_MB(K_ks+NAt-1) + 1
c$$$C
c$$$      Write (6, *) 'KLoc:  ', (KLoc(IShell), IShell = 1, NShell)
c$$$      Write (6, *) 'KAtom: ', (KAtom(IShell), IShell = 1, NShell)
c$$$      Write (6, *) 'KS:    ', (Int_MB( K_KS+IAtom-1), IAtom = 1, NAt)
c$$$      Write (6, *) 'NMS:   ', (Int_MB( K_NMS+IAtom-1), IAtom = 1, NAt)
c$$$      Write (6, *) 'KTop:  ', (Int_MB( K_KTop+IShell-1),
c$$$     $   IShell = 1, NShell)
c$$$      Call FFFLush(6)
C
      Return
      End
