      Subroutine defNxyz(lambda,ic,Nxyz)
c
c$Id: defNxyz.f,v 1.1 1993/08/31 01:26:36 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Save linit

      Parameter(lRmax=20,lRmax3=((lRmax+1)*(lRmax+2)*(lRmax+3))/6)

      Dimension Nxyz(3),Ixyz(3,lRmax3)
c
c Define the ordering of components in shells with increasing angular momentum.
c
c     Data p/ 1,0,0,
c    &        0,1,0,
c    &        0,0,1 /
c
c     Data d/ 2,0,0,
c    &        1,1,0,
c    &        1,0,1,
c    &        0,2,0,
c    &        0,1,1,
c    &        0,0,2 /
c
c     Data f/ 3,0,0,
c    &        2,1,0,
c    &        2,0,1,
c    &        1,2,0,
c    &        1,1,1,
c    &        1,0,2,
c    &        0,3,0,
c    &        0,2,1,
c    &        0,1,2,
c    &        0,0,3 /
c
c     etc.
c
c******************************************************************************

c Initialize the "Ixyz" data structure up through the given angular momentum.

      if( lambda .lt. 0 )then

       lambda = 4*abs(lambda)

       if( lambda .gt. lRmax )then
        write(*,*) 'DEFNXYZ:  Increase dimension of Ixyz to define the'
        write(*,*) '          order of shell components up through L=',
     &                        lambda
        write(*,*) '          Change parameter lRmax in defNxyz.f'
        write(*,*) '          lRmax = 4*(highest angular momentum ',
     &             'in basis)'
        stop
       end if

       nc = 0

       do 20 l0 = 0,lambda

        do 10 l1 = l0,0,-1
        do 10 l2 = l0-l1,0,-1

         nc = nc + 1

         Ixyz(1,nc) = l1
         Ixyz(2,nc) = l2
         Ixyz(3,nc) = l0 - (l1 + l2)

   10   continue

   20  continue

       linit = lambda

       return

      end if

c Define the angular momentum indices for the given shell component.

      if( lambda .le. linit )then

       l = lambda - 1
       l3 = ((l+1)*(l+2)*(l+3))/6

       nc = l3 + ic

       Nxyz(1) = Ixyz(1,nc)
       Nxyz(2) = Ixyz(2,nc)
       Nxyz(3) = Ixyz(3,nc)

      else

       write(*,*) 'DEFNXYZ:  Order for shell components was initialized'
       write(*,*) '          for shells with L <= ',linit,'.'
       write(*,*) '          Initialization should include shells with'
       write(*,*) '          L <= ',lambda,'.'
       stop

      end if

      end
