      Subroutine hf1mkr(C,zan,ncenters,
     &                  alpha,P,RS,PC,ff,R,
     &                  R0,NLM,NAB,Lp,Lp3)
c
c$Id: hf1mkr.f,v 1.1 1993/08/31 01:26:43 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (PI=3.1415926535898D0,PI4=4.D0/PI)

      Dimension C(3,ncenters),zan(ncenters)

      Dimension alpha(3,NAB),P(3,NAB)

      Dimension RS(NAB),PC(NAB,3),ff(2,NAB),R(NAB,0:Lp,Lp3)

      Dimension R0(NAB,Lp3),NLM(0:Lp,0:Lp,0:Lp)
c
c Define the auxiliary function integrals necessary to compute the nuclear
c attraction integrals (NAIs). These integrals are scaled by an appropriate
c factor, RS, defined as
c
c         / a + b \ 1/2
c   RS = | ------- |
c         \  PI/4 /
c
c The scale factor for the Hermite expansion coefficients is assumed to be
c
c         /   PI  \ 3/2     /   a b   __2 \
c   ES = | ------- |    EXP| - -----  AB   |
c         \ a + b /         \  a + b      /
c
c Therefore,
c
c            2 PI        /   a b   __2 \
c   ES RS = -------  EXP| - -----  AB   |
c            a + b       \  a + b      /
c
c******************************************************************************

      do 100  m = 1,NAB*Lp3
       R0(m,1) = 0.D0
  100 continue

      do 110 m = 1,NAB
       RS(m) = sqrt((alpha(1,m) + alpha(2,m))*PI4)
  110 continue

c Sum over all centers.

      do 150 ic = 1,ncenters

c Define factors necessary to compute incomplete gamma function and the
c auxiliary functions.

       do 120 m = 1,NAB

        alpha_t = alpha(1,m) + alpha(2,m)

        ff(1,m) = RS(m)
        ff(2,m) = -2.D0*alpha_t

        PCx = P(1,m) - C(1,ic)
        PCy = P(2,m) - C(2,ic)
        PCz = P(3,m) - C(3,ic)

        R(m,0,1) = alpha_t*(PCx**2 + PCy**2 + PCz**2)

        PC(m,1) = PCx
        PC(m,2) = PCy
        PC(m,3) = PCz

  120  continue

c Evaluate the incomplete gamma function.

       call igamma(R,NAB,Lp)

c Define the initial auxiliary functions (i.e., R000j, j=1,Lr).

       do 135 j = 0,Lp
        do 130 m = 1,NAB
         R(m,j,1) = ff(1,m)*R(m,j,1)
         ff(1,m) = ff(1,m)*ff(2,m)
  130   continue
  135  continue

c Recursively build the remaining auxiliary functions (i.e., RNLMj, j=0).

       call hfmkr(R,NLM,PC,NAB,Lp,Lp3)

c Transfer to R0 array.

       do 145 n = 1,Lp3
        do 140 m = 1,NAB
         R0(m,n) = R0(m,n) - zan(ic)*R(m,0,n)
  140   continue
  145  continue

  150 continue

      end
