      Subroutine hf1s(xyz,ncenters,
     &                Axyz,Aprims,Acoef,NPA,La,
     &                Bxyz,Bprims,Bcoef,NPB,Lb,
     &                W0,maxW0)
c
c$Id: hf1s.f,v 1.1 1993/08/31 01:26:44 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (Li=1)

      Dimension xyz(3,ncenters)

      Dimension Axyz(3),Aprims(NPA),Acoef(NPA)
      Dimension Bxyz(3),Bprims(NPB),Bcoef(NPB)

      Dimension W0(maxW0)

      Dimension Nxyz(3,2)

c******************************************************************************

c Define the number of shell components on each center.

      La2 = ((La+1)*(La+2))/2
      Lb2 = ((Lb+1)*(Lb+2))/2

c Assign pointers to scratch space.

      iw1  = 1
      iw4  = iw1  + La2*Lb2
      iwl  = iw4  + (NPA*NPB)*3 - 1

      if( iwl.gt.maxW0 )then

       write(*,*) 'HF1S:  Insufficient scratch space.'
       write(*,*) '       needed    ',iwl
       write(*,*) '       allocated ',maxW0

       print *,'Sab (C):  iw1  ',iw1
       print *,'alpha  :  iw4  ',iw4 
       print *,'last   :  iwl  ',iwl,maxW0

       stop

      end if

c Define the prefactor of the charge distribution.

      call hf1set(Axyz,Aprims,Acoef,NPA,
     &            Bxyz,Bprims,Bcoef,NPB,
     &            W0(iw4),NAB)

c Assign pointers to scratch space.

      iw5  = iw4  + NAB*3
      iw8  = iw5  + NAB*3*((La+Li)+(Lb+Li)+1)*((La+Li)+1)*((Lb+Li)+1)
      iw9  = iw8  + NAB*3
      iw10 = iw9  + NAB*3
      iwl  = iw10 + NAB*3 - 1

      if( iwl.gt.maxW0 )then

       write(*,*) 'HF1S:  Insufficient scratch space.'
       write(*,*) '       needed    ',iwl
       write(*,*) '       allocated ',maxW0

       print *,'Sab (C):  iw1  ',iw1
       print *,'alpha  :  iw4  ',iw4 
       print *,'E      :  iw5  ',iw5
       print *,'P      :  iw8  ',iw8
       print *,'PT     :  iw9  ',iw9
       print *,'AB2I   :  iw10 ',iw10
       print *,'last   :  iwl  ',iwl,maxW0

       stop

      end if

c Define the center of the charge distribution.

      call hfctr2(Axyz,Bxyz,W0(iw4),W0(iw8),NAB)

c Define the Hermite linear expansion coefficients.

      call hf1mke(Axyz,Bxyz,W0(iw4),W0(iw8),W0(iw9),W0(iw10),
     &            W0(iw5),NAB,La,Lb)

c Loop over shell components.

      mm = -1
      do 20 ica = 1,La2
       do 10 icb = 1,Lb2
        mm = mm + 1

c Define the angular momentum indices.

        call defNxyz(La,ica,Nxyz(1,1))
        call defNxyz(Lb,icb,Nxyz(1,2))

c Compute <a|S|b>.

        call hfasb(W0(iw5),Nxyz,W0(iw1+mm),NAB,La,Lb)

   10  continue
   20 continue

      end
