      Subroutine hf2mkr(alpha_p,alpha_q,P,Q,PQ,ff,R,R0,NLM,
     &                  NAB,NCD,Lr,Lr3)
c
c$Id: hf2mkr.f,v 1.1 1993/08/31 01:26:49 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Dimension alpha_p(3,NAB),alpha_q(3,NCD),P(3,NAB),Q(3,NCD),
     & PQ(NAB*NCD,3),ff(2,NAB*NCD),R(NAB*NCD,0:Lr,Lr3)

      Dimension R0(NAB*NCD,Lr3),NLM(0:Lr,0:Lr,0:Lr)
c
c Define the auxiliary function integrals. These integrals are scaled by a 
c factor appropriate for ERIs, defined as
c
c                      -1/2
c  ESR = ESP ESQ (p + q)
c
c  where p = a + b, q = c + d
c
c           1/2   5/4
c          2    PI        /   a b   __2 \
c  ESP =  ---------   EXP| - -----  AB   |
c           a + b         \  a + b      /
c
c           1/2   5/4
c          2    PI        /   c d   __2 \
c  ESQ =  ---------   EXP| - -----  CD   |
c           c + d         \  c + d      /
c
c The ESP and ESQ scaling factors are passed as the 3rd indices of the 
c exponents array (i.e., "alpha_p(3,m)" and "alpha_q(3,m)").
c
c******************************************************************************

c Define factors necessary to compute incomplete gamma function and the
c auxiliary functions.

      mr = 0
      do 120 mp = 1,NAB
      do 120 mq = 1,NCD
       mr = mr + 1

       ap = alpha_p(1,mp) + alpha_p(2,mp)
       aq = alpha_q(1,mq) + alpha_q(2,mq)

       RS = 1/(ap + aq)

       alpha_t = ap*aq*RS

       ff(1,mr) = alpha_p(3,mp)*alpha_q(3,mq)*sqrt(RS)
       ff(2,mr) = -2.D0*alpha_t

       PQx = P(1,mp) - Q(1,mq)
       PQy = P(2,mp) - Q(2,mq)
       PQz = P(3,mp) - Q(3,mq)

       R(mr,0,1) = alpha_t*(PQx**2 + PQy**2 + PQz**2)

       PQ(mr,1) = PQx
       PQ(mr,2) = PQy
       PQ(mr,3) = PQz

  120 continue

c Evaluate the incomplete gamma function.

      call igamma(R,NAB*NCD,Lr)

c Define the initial auxiliary functions (i.e., R000j, j=1,Lr).

      do 135 j = 0,Lr
       do 130 mr = 1,NAB*NCD
        R(mr,j,1) = ff(1,mr)*R(mr,j,1)
        ff(1,mr) = ff(1,mr)*ff(2,mr)
  130  continue
  135 continue

c Recursively build the remaining auxiliary functions (i.e., RNLMj, j=0).

      call hfmkr(R,NLM,PQ,NAB*NCD,Lr,Lr3)

c Transfer to R0 array.

      do 145 n = 1,Lr3
       do 140 mr = 1,NAB*NCD
        R0(mr,n) = R(mr,0,n)
  140  continue
  145 continue

      end
