      Subroutine hf2set(Axyz,Aprims,Acoef,NPA,
     &                  Bxyz,Bprims,Bcoef,NPB,
     &                  alpha,NAB)
c
c$Id: hf2set.f,v 1.2 1993/10/03 10:52:01 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (P1=0.5914967172795629D+01)
c       1/2   5/4
c P1 = 2    PI
c
      Parameter (EXPLIM=100.D0)
      Parameter (ACCY=1.D-16)

      Dimension Axyz(3),Aprims(NPA),Acoef(NPA)
      Dimension Bxyz(3),Bprims(NPB),Bcoef(NPB)

      Dimension alpha(3,NPA*NPB)
c
c The prefactor of the charge distribution, formed by the product of 
c two Gaussians, is defined as
c
c           1/2   5/4
c          2    PI        /   a b   __2 \
c   ES =  ---------   EXP| - -----  AB   |
c           a + b         \  a + b      /
c
c N.B. 1) This prefactor is returned as the 3rd index of the exponents array.
c         (i.e., "alpha(3,m)") 
c      2) Charge distributions, whose prefactor is less than a given tolerance,
c         are removed from the list. The shortened list is of length "NAB".
c      3) The product of contraction coefficients is also incorporated in
c         the prefactor. For a general contraction implementation, this 
c         should not be done at this point.
c
c******************************************************************************

      m = 0
      do 10 ipa = 1,NPA
      do 10 ipb = 1,NPB
       m = m + 1

       alpha(1,m) = Aprims(ipa)
       alpha(2,m) = Bprims(ipb)

       alpha(3,m) = Acoef(ipa)*Bcoef(ipb)

   10 continue

      Ax = Axyz(1)
      Ay = Axyz(2)
      Az = Axyz(3)

      Bx = Bxyz(1)
      By = Bxyz(2)
      Bz = Bxyz(3)

      RABsq = (Ax-Bx)**2 + (Ay-By)**2 + (Az-Bz)**2

      m2 = 0
      do 20 m1 = 1,NPA*NPB

       A = alpha(1,m1)
       B = alpha(2,m1)

       ABI = 1/(A + B)

       s = P1*ABI

       ES = s*exp(-min(EXPLIM,A*B*ABI*RABsq))

       if( ES .gt. ACCY )then

        m2 = m2 + 1

        alpha(1,m2) = A
        alpha(2,m2) = B

        alpha(3,m2) = ES*alpha(3,m1)

       end if

   20 continue

      NAB = m2

      end
