      Subroutine hf3ctr(Axyz,Aprims,Acoef,NPA,La,
     &                  Bxyz,Bprims,Bcoef,NPB,Lb,
     &                  Cxyz,Cprims,Ccoef,NPC,Lc,
     &                  W0,maxW0)
c
c$Id: hf3ctr.f,v 1.1 1993/08/31 01:26:53 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Dimension Axyz(3),Aprims(NPA),Acoef(NPA)
      Dimension Bxyz(3),Bprims(NPB),Bcoef(NPB)
      Dimension Cxyz(3),Cprims(NPC),Ccoef(NPC)

      Dimension W0(maxW0)

c******************************************************************************

c Define the number of shell components on each center.

      La2 = ((La+1)*(La+2))/2
      Lb2 = ((Lb+1)*(Lb+2))/2
      Lc2 = ((Lc+1)*(Lc+2))/2

c Assign pointers to scratch space.

      iw1  = 1
      iw2  = iw1  + La2*Lb2*Lc2
      iwl  = iw2  + (NPA*NPB*NPC)*4 - 1

      if( iwl.gt.maxW0 )then

       write(*,*) 'HF3CTR:  Insufficient scratch space.'
       write(*,*) '         needed    ',iwl
       write(*,*) '         allocated ',maxW0

       print *,'Sabc (C):  iw1  ',iw1
       print *,'alpha   :  iw2  ',iw2
       print *,'last    :  iwl  ',iwl,maxW0

       stop

      end if

c Define the prefactor of the charge distribution.

      call hf1set3(Axyz,Aprims,Acoef,NPA,
     &             Bxyz,Bprims,Bcoef,NPB,
     &             Cxyz,Cprims,Ccoef,NPC,
     &             W0(iw2),NABC)

c Assign pointers to scratch space.

      iw3  = iw2  + NABC*4
      iw4  = iw3  + NABC*3*(La+Lb+Lc+1)*(La+1)*(Lb+1)*(Lc+1)
      iwl  = iw4  + NABC*3 - 1

      if( iwl.gt.maxW0 )then

       write(*,*) 'HF3CTR:  Insufficient scratch space.'
       write(*,*) '         needed    ',iwl
       write(*,*) '         allocated ',maxW0

       print *,'Sabc (C):  iw1  ',iw1
       print *,'alpha   :  iw2  ',iw2
       print *,'E       :  iw3  ',iw3
       print *,'G       :  iw4  ',iw4
       print *,'last    :  iwl  ',iwl,maxW0

       stop

      end if

c Define the center of the charge distribution.

      call hfctr3(Axyz,Bxyz,Cxyz,W0(iw2),W0(iw4),NABC)

c Assign pointers to scratch space.

      iw5  = iw4  + NABC*3
      iw6  = iw5  + NABC*3
      iwl  = iw6  + NABC*3 - 1

      if( iwl.gt.maxW0 )then

       write(*,*) 'HF3CTR:  Insufficient scratch space.'
       write(*,*) '         needed    ',iwl
       write(*,*) '         allocated ',maxW0

       print *,'Sabc (C):  iw1  ',iw1
       print *,'alpha   :  iw2  ',iw2
       print *,'E       :  iw3  ',iw3
       print *,'G       :  iw4  ',iw4
       print *,'GT      :  iw5  ',iw5
       print *,'ABC2I   :  iw6  ',iw6
       print *,'last    :  iwl  ',iwl,maxW0

       stop

      end if

c Define the Hermite linear expansion coefficients.

      call hf1mke3(Axyz,Bxyz,Cxyz,W0(iw2),W0(iw4),W0(iw5),W0(iw6),
     &             W0(iw3),NABC,La,Lb,Lc)

c Compute the 3-ctr OIs.

      call hfabc(W0(iw3),W0(iw1),NABC,La,Lb,Lc)

      end
