      Subroutine hfatb(alpha,E,Nxyz,Tab,Ti,NAB,La,Lb)
c
c$Id: hfatb.f,v 1.1 1993/08/31 01:26:56 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (Li=1)

      Dimension E(NAB,3,0:((La+Li)+(Lb+Li)),0:(La+Li),0:(Lb+Li))

      Dimension alpha(3,NAB),Nxyz(3,2),Ti(NAB)
c
c Compute the kinetic energy integrals.
c
c     Formula:                                                       
c
c            1  /  Ia,Ib   Ja,Jb   Ka,Kb                       \
c     Tab =  - | T      Ey      Ez      + "Y-term" + "Z-term"   |
c            2  \  X       0       0                           /
c                                                                     
c      i,j         i-1,j-1      i-1,j+1       i+1,j-1       i+1,j+1   
c     T      = ijEx       - 2ibEx      - 2ajEx       + 4abEx          
c      X           0             0            0             0
c                                                                     
c******************************************************************************

      Ia = Nxyz(1,1)
      Ja = Nxyz(2,1)
      Ka = Nxyz(3,1)

      Ib = Nxyz(1,2)
      Jb = Nxyz(2,2)
      Kb = Nxyz(3,2)

      Tab = 0.D0

c Build Tx.

      if( Ia.gt.0 .and. Ib.gt.0 )then

       do 100 m = 1,NAB
        Ti(m) =   0.5D0*(        Ia*Ib        )*E(m,1,0,Ia-1,Ib-1)
     &          -       (        Ia*alpha(2,m))*E(m,1,0,Ia-1,Ib+1)
     &          -       (alpha(1,m)*Ib        )*E(m,1,0,Ia+1,Ib-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,1,0,Ia+1,Ib+1)
  100  continue

      else if( Ia.gt.0 )then

       do 110 m = 1,NAB
        Ti(m) = -       (        Ia*alpha(2,m))*E(m,1,0,Ia-1,Ib+1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,1,0,Ia+1,Ib+1)
  110  continue

      else if( Ib.gt.0 )then

       do 120 m = 1,NAB
        Ti(m) = -       (alpha(1,m)*Ib        )*E(m,1,0,Ia+1,Ib-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,1,0,Ia+1,Ib+1)
  120  continue

      else

       do 130 m = 1,NAB
        Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(m,1,0,Ia+1,Ib+1)
  130  continue

      end if

c Add Tx*Ey*Ez to Tab

      do 140 m = 1,NAB
       Tab = Tab + Ti(m)*E(m,2,0,Ja,Jb)*E(m,3,0,Ka,Kb)
  140 continue

c Build Ty.

      if( Ja.gt.0 .and. Jb.gt.0 )then

       do 200 m = 1,NAB
        Ti(m) =   0.5D0*(        Ja*Jb        )*E(m,2,0,Ja-1,Jb-1)
     &          -       (        Ja*alpha(2,m))*E(m,2,0,Ja-1,Jb+1)
     &          -       (alpha(1,m)*Jb        )*E(m,2,0,Ja+1,Jb-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,2,0,Ja+1,Jb+1)
  200  continue

      else if( Ja.gt.0 )then

       do 210 m = 1,NAB
        Ti(m) = -       (        Ja*alpha(2,m))*E(m,2,0,Ja-1,Jb+1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,2,0,Ja+1,Jb+1)
  210  continue

      else if( Jb.gt.0 )then

       do 220 m = 1,NAB
        Ti(m) = -       (alpha(1,m)*Jb        )*E(m,2,0,Ja+1,Jb-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,2,0,Ja+1,Jb+1)
  220  continue

      else

       do 230 m = 1,NAB
        Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(m,2,0,Ja+1,Jb+1)
  230  continue

      end if

c Add Ex*Ty*Ez to Tab.

      do 240 m = 1,NAB
       Tab = Tab + E(m,1,0,Ia,Ib)*Ti(m)*E(m,3,0,Ka,Kb)
  240 continue

c Build Tz.

      if( Ka.gt.0 .and. Kb.gt.0 )then

       do 300 m = 1,NAB
        Ti(m) =   0.5D0*(        Ka*Kb        )*E(m,3,0,Ka-1,Kb-1)
     &          -       (        Ka*alpha(2,m))*E(m,3,0,Ka-1,Kb+1)
     &          -       (alpha(1,m)*Kb        )*E(m,3,0,Ka+1,Kb-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,3,0,Ka+1,Kb+1)
  300  continue

      else if( Ka.gt.0 )then

       do 310 m = 1,NAB
        Ti(m) = -       (        Ka*alpha(2,m))*E(m,3,0,Ka-1,Kb+1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,3,0,Ka+1,Kb+1)
  310  continue

      else if( Kb.gt.0 )then

       do 320 m = 1,NAB
        Ti(m) = -       (alpha(1,m)*Kb        )*E(m,3,0,Ka+1,Kb-1)
     &          + 2.0D0*(alpha(1,m)*alpha(2,m))*E(m,3,0,Ka+1,Kb+1)
  320  continue

      else

       do 330 m = 1,NAB
        Ti(m) =   2.0D0*(alpha(1,m)*alpha(2,m))*E(m,3,0,Ka+1,Kb+1)
  330  continue

      end if

c Add Ex*Ey*Tz to Tab.

      do 340 m = 1,NAB
       Tab = Tab + E(m,1,0,Ia,Ib)*E(m,2,0,Ja,Jb)*Ti(m)
  340 continue

      end
