      Subroutine hfavb(E,R0,NLM,Nxyz,Vab,NAB,La,Lb)
c
c$Id: hfavb.f,v 1.1 1993/08/31 01:26:57 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (Li=1)

      Dimension E(NAB,3,0:((La+Li)+(Lb+Li)),0:(La+Li),0:(Lb+Li))

      Dimension Nxyz(3,2)

      Dimension R0(NAB,*),NLM(0:La+Lb,0:La+Lb,0:La+Lb)
c
c Compute the nuclear attraction integrals.
c
c     formula:
c           __
c           \    Ia,Ib    Ja,Jb    Ka,Kb
c     Vab = /  Ex     * Ey     * Ez     * R
c           --   Ip       Jp       Kp      Ip,Jp,Kp
c        Ip,Jp,Kp
c
c******************************************************************************

      Ia = Nxyz(1,1)
      Ja = Nxyz(2,1)
      Ka = Nxyz(3,1)

      Ib = Nxyz(1,2)
      Jb = Nxyz(2,2)
      Kb = Nxyz(3,2)

      Vab = 0.D0

      do 30 Ip = 0,Ia+Ib
      do 30 Jp = 0,Ja+Jb
      do 30 Kp = 0,Ka+Kb

       n = NLM(Ip,Jp,Kp)

       do 20 m = 1,NAB
        Vab = Vab + 
     &          E(m,1,Ip,Ia,Ib)*E(m,2,Jp,Ja,Jb)*E(m,3,Kp,Ka,Kb)*R0(m,n)
   20  continue

   30 continue

      end
