      Subroutine hferi(Ep,Eq,R0,NLM,EEp,EEq,sum,ERI,
     &                 NAB,NCD,La,Lb,Lc,Ld)
c
c$Id: hferi.f,v 1.1 1993/08/31 01:27:01 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Dimension Ep(NAB,3,0:(La+Lb),0:La,0:Lb)
      Dimension Eq(NCD,3,0:(Lc+Ld),0:Lc,0:Ld)

      Dimension R0(NAB*NCD,*)
      Dimension NLM(0:La+Lb+Lc+Ld,0:La+Lb+Lc+Ld,0:La+Lb+Lc+Ld)

      Dimension ERI(*),sum(NAB*NCD)

      Dimension Nxyz(3)

      Dimension EEp(NAB,*),EEq(NCD,*)
c
c Compute ERIs.
c
c     Formula:
c           __
c           \     (Iq+Jq+Kq)   Ic,Id   Jc,Jd   Kc,Kd                        
c     SUM = /  (-1)          Ex      Ey      Ez      R
c           --                 Iq      Jq      Kq     Ip+Iq,Jp+Jq,Kp+Kq
c        Iq,Jq,Kq
c
c           __
c           \    Ia,Ib   Ja,Jb   Ka,Kb
c     ERI = /  Ex      Ey      Ez      SUM
c           --   Ip      Jp      Kp
c        Ip,Jp,Kp
c
c******************************************************************************

      if( (La+Lb) .eq. 0 )then

       if( (Lc+Ld) .eq. 0 )then

c Special case:  [SS||SS]
       
        ERI(1) = 0.D0
        do 100 mr = 1,NAB*NCD
         ERI(1) = ERI(1) + R0(mr,1)
  100   continue

       else

c Special case:  [SS||cd]

c Define the number of shell components on each center.

        Lc2 = ((Lc+1)*(Lc+2))/2
        Ld2 = ((Ld+1)*(Ld+2))/2

c Loop over shell components.

        mm = 0
        do 280 icc = 1,Lc2

         call defNxyz(Lc,icc,Nxyz(1))

         Ic = Nxyz(1)
         Jc = Nxyz(2)
         Kc = Nxyz(3)

         do 270 icd = 1,Ld2
          mm = mm + 1

          call defNxyz(Ld,icd,Nxyz(1))

          Id = Nxyz(1)
          Jd = Nxyz(2)
          Kd = Nxyz(3)

          ERI(mm) = 0.D0

          do 240 Iq = 0,Ic+Id
          do 240 Jq = 0,Jc+Jd
          do 240 Kq = 0,Kc+Kd

           n = NLM(Iq,Jq,Kq)

c Include the factor of (-1)**(Iq+Jq+Kq).

           if( mod(Iq+Jq+Kq,2).eq.0 )then

            mr = 0
            do 230 mp = 1,NAB
            do 230 mq = 1,NCD
             mr = mr + 1

             ERI(mm) = ERI(mm) + Eq(mq,1,Iq,Ic,Id)*
     &                           Eq(mq,2,Jq,Jc,Jd)*
     &                           Eq(mq,3,Kq,Kc,Kd)*R0(mr,n)

  230       continue

           else

            mr = 0
            do 235 mp = 1,NAB
            do 235 mq = 1,NCD
             mr = mr + 1

             ERI(mm) = ERI(mm) - Eq(mq,1,Iq,Ic,Id)*
     &                           Eq(mq,2,Jq,Jc,Jd)*
     &                           Eq(mq,3,Kq,Kc,Kd)*R0(mr,n)

  235       continue

           end if

  240     continue

  270    continue
  280   continue

       end if

      else if( (Lc+Ld) .eq. 0 )then

c Special case:  [ab||SS]

c Define the number of shell components on each center.

       La2 = ((La+1)*(La+2))/2
       Lb2 = ((Lb+1)*(Lb+2))/2

c Loop over shell components.

       mm = 0
       do 400 ica = 1,La2

         call defNxyz(La,ica,Nxyz(1))

         Ia = Nxyz(1)
         Ja = Nxyz(2)
         Ka = Nxyz(3)

        do 390 icb = 1,Lb2
         mm = mm + 1

         call defNxyz(Lb,icb,Nxyz(1))

         Ib = Nxyz(1)
         Jb = Nxyz(2)
         Kb = Nxyz(3)

         ERI(mm) = 0.D0

         do 360 Ip = 0,Ia+Ib
         do 360 Jp = 0,Ja+Jb
         do 360 Kp = 0,Ka+Kb

          n = NLM(Ip,Jp,Kp)

          mr = 0
          do 350 mp = 1,NAB
          do 350 mq = 1,NCD
           mr = mr + 1

           ERI(mm) = ERI(mm) + Ep(mp,1,Ip,Ia,Ib)*
     &                         Ep(mp,2,Jp,Ja,Jb)*
     &                         Ep(mp,3,Kp,Ka,Kb)*R0(mr,n)

  350     continue

  360    continue

  390   continue
  400  continue

      else

c General case:  [ab||cd]

c Define the number of shell components on each center.

       La2 = ((La+1)*(La+2))/2
       Lb2 = ((Lb+1)*(Lb+2))/2
       Lc2 = ((Lc+1)*(Lc+2))/2
       Ld2 = ((Ld+1)*(Ld+2))/2

c Loop over shell components.

       mm = 0
       do 500 ica = 1,La2

        call defNxyz(La,ica,Nxyz(1))

        Ia = Nxyz(1)
        Ja = Nxyz(2)
        Ka = Nxyz(3)

        do 490 icb = 1,Lb2

         call defNxyz(Lb,icb,Nxyz(1))

         Ib = Nxyz(1)
         Jb = Nxyz(2)
         Kb = Nxyz(3)

c Define the product of the Hermite expansions coefficients for 
c charge distribution "P".

         np = 0
         do 415 Ip = 0,Ia+Ib
         do 415 Jp = 0,Ja+Jb
         do 415 Kp = 0,Ka+Kb
          np = np + 1

          do 410 mp = 1,NAB
           EEp(mp,np) = Ep(mp,1,Ip,Ia,Ib)*
     &                  Ep(mp,2,Jp,Ja,Jb)*
     &                  Ep(mp,3,Kp,Ka,Kb)
  410     continue

  415    continue

         do 480 icc = 1,Lc2

          call defNxyz(Lc,icc,Nxyz(1))

          Ic = Nxyz(1)
          Jc = Nxyz(2)
          Kc = Nxyz(3)

          do 470 icd = 1,Ld2
           mm = mm + 1

           call defNxyz(Ld,icd,Nxyz(1))

           Id = Nxyz(1)
           Jd = Nxyz(2)
           Kd = Nxyz(3)

c Define the product of the Hermite expansions coefficients for 
c charge distribution "Q".

           nq = 0
           do 430 Iq = 0,Ic+Id
           do 430 Jq = 0,Jc+Jd
           do 430 Kq = 0,Kc+Kd
            nq = nq + 1

c Include the factor of (-1)**(Iq+Jq+Kq).

            if( mod(Iq+Jq+Kq,2).eq.0 )then

             do 420 mq = 1,NCD
              EEq(mq,nq) = Eq(mq,1,Iq,Ic,Id)*
     &                     Eq(mq,2,Jq,Jc,Jd)*
     &                     Eq(mq,3,Kq,Kc,Kd)
  420        continue

            else

             do 425 mq = 1,NCD
              EEq(mq,nq) = -Eq(mq,1,Iq,Ic,Id)*
     &                      Eq(mq,2,Jq,Jc,Jd)*
     &                      Eq(mq,3,Kq,Kc,Kd)
  425        continue

            end if

  430      continue

c Compute the ERIs.

           ERI(mm) = 0.D0

           np = 0
           do 460 Ip = 0,Ia+Ib
           do 460 Jp = 0,Ja+Jb
           do 460 Kp = 0,Ka+Kb
            np = np + 1

            do 435 mr = 1,NAB*NCD
             sum(mr) = 0.D0
  435       continue

            nq = 0
            do 445 Iq = 0,Ic+Id
            do 445 Jq = 0,Jc+Jd
            do 445 Kq = 0,Kc+Kd
             nq = nq + 1

             nr = NLM(Ip+Iq,Jp+Jq,Kp+Kq)

             mr = 0
             do 440 mp = 1,NAB
             do 440 mq = 1,NCD
              mr = mr + 1

              sum(mr) = sum(mr) + EEq(mq,nq)*R0(mr,nr)

  440        continue

  445       continue

            mr = 0
            do 450 mp = 1,NAB
            do 450 mq = 1,NCD
             mr = mr + 1

             ERI(mm) = ERI(mm) + EEp(mp,np)*sum(mr)

  450       continue

  460      continue

  470     continue
  480    continue
  490   continue
  500  continue

      end if

      end
