      Subroutine hfmkr(R,NLM,PQ,NAB,Lp,Lp3)
c
c$Id: hfmkr.f,v 1.1 1993/08/31 01:27:06 gg502 Exp $
c

      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Dimension R(NAB,0:Lp,Lp3),NLM(0:Lp,0:Lp,0:Lp),PQ(NAB,3)

      Dimension Nxyz(3)
c
c Recursively define the auxiliary integrals needed for ERIs and NAIs.
c
c     Recursion Formula:
c
c        R        = PQx R            + (N-1) R
c         N,L,M,j        N-1,L,M,j+1          N-2,L,M,j+1
c
c        R        = PQy R            + (L-1) R
c         N,L,M,j        N,L-1,M,j+1          N,L-2,M,j+1
c
c        R        = PQz R            + (M-1) R
c         N,L,M,j        N,L,M-1,j+1          N,L,M-2,j+1
c
c******************************************************************************

      n0 = 1

      NLM(0,0,0) = n0

      do 180 l = 1,Lp

       l2 = ((l+1)*(l+2))/2

       do 170 i = 1,l2

        call defNxyz(l,i,Nxyz)

        Ip = Nxyz(1)
        Jp = Nxyz(2)
        Kp = Nxyz(3)

        n0 = n0 + 1

        NLM(Ip,Jp,Kp) = n0

        if( Ip.gt.0 )then

         if( Ip.eq.1 )then

          n1 = NLM(Ip-1,Jp,Kp)

          do 115 j = 0,Lp-l
           do 110 m = 1,NAB
            R(m,j,n0) = PQ(m,1)*R(m,j+1,n1)
  110      continue
  115     continue

         else

          n1 = NLM(Ip-1,Jp,Kp)
          n2 = NLM(Ip-2,Jp,Kp)

          do 125 j = 0,Lp-l
           do 120 m = 1,NAB
            R(m,j,n0) = PQ(m,1)*R(m,j+1,n1) + (Ip-1)*R(m,j+1,n2)
  120      continue
  125     continue

         end if

        else if( Jp.gt.0 )then

         if( Jp.eq.1 )then

          n1 = NLM(Ip,Jp-1,Kp)

          do 135 j = 0,Lp-l
           do 130 m = 1,NAB
            R(m,j,n0) = PQ(m,2)*R(m,j+1,n1)
  130      continue
  135     continue

         else

          n1 = NLM(Ip,Jp-1,Kp)
          n2 = NLM(Ip,Jp-2,Kp)

          do 145 j = 0,Lp-l
           do 140 m = 1,NAB
            R(m,j,n0) = PQ(m,2)*R(m,j+1,n1) + (Jp-1)*R(m,j+1,n2)
  140      continue
  145     continue

         end if

        else if( Kp.gt.0 )then

         if( Kp.eq.1 )then

          n1 = NLM(Ip,Jp,Kp-1)

          do 155 j = 0,Lp-l
           do 150 m = 1,NAB
            R(m,j,n0) = PQ(m,3)*R(m,j+1,n1)
  150      continue
  155     continue

         else

          n1 = NLM(Ip,Jp,Kp-1)
          n2 = NLM(Ip,Jp,Kp-2)

          do 165 j = 0,Lp-l
           do 160 m = 1,NAB
            R(m,j,n0) = PQ(m,3)*R(m,j+1,n1) + (Kp-1)*R(m,j+1,n2)
  160      continue
  165     continue

         end if

        end if

  170  continue

  180 continue

      end
