      Subroutine intmem(ienv,mem1,mem2,max1e,maxg)
c
c$Id: intmem.f,v 1.1 1993/08/31 01:27:10 gg502 Exp $
c
c
c This subroutine approximates the maximum memory required 
c by the integrals routines 
c
c Input:
c ienv := pointer to environment
c
c Output:
c mem1  := memory required to calculate one electron integrals
c mem2  := memory required to calculate two electron integrals
c max1e := memory required for 1e-integrals and index arrays(2)
c maxg  := memory required for 2e-integrals and index arrays(4)
      implicit none
      integer ienv,mem1,mem2,max1e,maxg
      include 'int.h'
c
c check that environment is okay
c
      if (ienv.ne.565) then
        write(6,*)' environment not set call intinit first '
        stop ' env error '
      endif
c
      mem1   = mem_scr_1
      mem2   = mem_scr_2
      max1e  = mem_max1e
      maxg   = mem_maxg
      return
      end
      subroutine exact_mem()
      implicit none
      include 'int.h'
c . . . . . . . . . . . . . . . . . . . . ! calculate 1&2 electron memory
c:local      
      integer ish,jsh
      integer ish_type,jsh_type
      integer ish_nprim,jsh_nprim
      integer memdum
      integer maxang
c
      maxang = -1
c
      mem_scr_1 = 0
      mem_scr_2 = 0
c
      do 00100 ish=1,nshell
        ish_type  = ktype(ish)-1
        ish_nprim = kng(ish)
        maxang = max(maxang,ktype(ish))
        do 00200 jsh=1,ish
          jsh_type  = ktype(jsh)-1
          jsh_nprim = kng(jsh)
          memdum = 9000000
          call hf1(c,zan,nat,c,ex,cspd,
     &           ish_nprim,ish_type,
     &           c,ex,cspd,
     &           jsh_nprim,jsh_type,
     &           ex,memdum,.true.)
          mem_scr_1 = max(mem_scr_1,memdum)
          memdum = 9000000
          call hf2(
     &           c,ex,cspd,ish_nprim,ish_type,
     &           c,ex,cspd,jsh_nprim,jsh_type,
     &           c,ex,cspd,ish_nprim,ish_type,
     &           c,ex,cspd,jsh_nprim,jsh_type,
     &           ex,memdum,.true.)
          mem_scr_2 = max(mem_scr_2,memdum)
00200   continue
00100 continue
      maxang    = maxang*(maxang+1)/2
      mem_max1e = 3*maxang*maxang
      mem_maxg  = maxang**4
c      write(6,'(a,i8)')' mem_scr_1  = ',mem_scr_1
c      write(6,'(a,i8)')' mem_max1e  = ',mem_max1e
c      write(6,'(a,i8)')' mem_scr_2  = ',mem_scr_2
c      write(6,'(a,i8)')' mem_maxg   = ',mem_maxg
      end  
c  c
c        Function icmem2(La,Lb,Lc,Ld,npa,npb,npc,npd)
c        implicit integer(a-z)
c  c
c        La2 = ((La+1)*(La+2))/2
c        Lb2 = ((Lb+1)*(Lb+2))/2
c        Lc2 = ((Lc+1)*(Lc+2))/2
c        Ld2 = ((Ld+1)*(Ld+2))/2
c        Lp = La + Lb
c        Lq = Lc + Ld
c        Lr = Lp + Lq
c        Lr3 = ((Lr+1)*(Lr+2)*(Lr+3))/6
c  
c        NAB   = npa*npb
c        NCD   = npc*npd
c        NAB3  = NAB*3
c        NCD3  = NCD*3
c        NABCD = NAB*NCD
c  
c  c            ERI's             alpha_p   alphaq
c        mem2 = La2*Lb2*Lc2*Ld2 + NAB3    + NCD3   
c  
c  c                     Ep and Eq
c        mem2 = mem2 + NAB3*(La+Lb+1)*(La+1)*(Lb+1) +
c       &              NCD3*(Lc+Ld+1)*(Lc+1)*(Ld+1)
c  
c  c                   R0             ijk
c        mem2 = mem2 + NABCD*lr3 +  (Lr+1)**3
c  
c  c               P     Q     PA, PB, AB2I
c        mem2a = NAB3 + NCD3 + 3*max(NAB3,NCD3)
c  
c  c               P     Q       PQ       ff         Rj
c        mem2b = NAB3 + NCD3 + NABCD*3 + NABCD*2 + NABCD*(Lr+1)*Lr3
c  
c  c              sum
c        mem2c = NABCD
c  
c        icmem2 = mem2 + max(mem2a,mem2b,mem2c)
c        icmem2 = icmem2+1
c        end
c  
c        Function icmem1(la,lb,npa,npb)
c        implicit integer(a-z)
c  c
c        icmem1 = 0
c        La2 = ((La+1)*(La+2))/2
c        Lb2 = ((Lb+1)*(Lb+2))/2
c        Li  = 1
c        Lp  = La + Lb
c        Lp3 = (Lp+1)*(Lp+2)*(Lp+3)/6
c  
c  c
c        NAB  = npa*npb
c        NAB3 = 3*NAB
c  
c  c             S,T,V       exp+prefact  
c  
c        mem1m = 3*La2*Lb2 + NAB3
c  
c  c  E
c        mem1m = mem1m + NAB3*((La+Li)+(Lb+Li)+1)*((La+Li)+1)*((Lb+Li)+1)
c  
c  c                       R0        ijk     
c        mem1m = mem1m + NAB*Lp3 + (Lp+1)**3 
c  c              P     PA      PB      AB2i
c        mem1a = NAB3 + NAB3 + NAB3 + NAB3
c  
c  c             P       RS    PC     ff         Rj
c        mem1b = NAB3 + NAB + NAB3 + NAB*2 + NAB*(Lp+1)*Lp3
c  
c  c             Ti
c        mem1c = NAB
c  
c        icmem1 = mem1m + max(mem1a,mem1b,mem1c)
c        icmem1 = icmem1 + 1
c        end
c  
c        subroutine apx_mem_2(mem2,maxg)
c        implicit none
c        include 'int.h'
c  c:passed
c        integer mem2, maxg
c  c:local
c        integer ish,jsh
c        integer ish_type,jsh_type
c        integer ish_ng,jsh_ng
c        integer ish_size,jsh_size
c        integer maxprimi,maxprimj,maxprimk,maxpriml
c        integer maxshltypei,maxshltypej,maxshltypek,maxshltypel
c        integer mcurrentij, mtestij
c        integer memdum, maxang
c  c
c        maxprimi    = -1
c        maxprimj    = -1
c        maxshltypei = -1
c        maxshltypej = -1
c        mcurrentij  = 0
c        maxg        = 0
c        maxang      = -1
c  c
c        do 00100 ish = 1,nshell
c          ish_type = ktype(ish)
c          ish_ng   = kng(ish)
c          ish_size = ish_ng*ish_type*(ish_type+1)/2
c  c        ish_size = ish_ng*ish_type
c          maxang   = max(maxang, ish_type)
c          
c          do 00200 jsh = 1,ish
c            jsh_type = ktype(jsh)
c            jsh_ng   = kng(jsh)
c            jsh_size = jsh_ng*jsh_type*(jsh_type+1)/2
c  c          jsh_size = jsh_ng*jsh_type
c            
c            mtestij = ish_size + jsh_size
c            if (mtestij .gt. mcurrentij) then
c              mcurrentij  = mtestij
c              maxprimi    = ish_ng
c              maxprimj    = jsh_ng
c              maxshltypei = ish_type
c              maxshltypej = jsh_type
c            endif
c            
c  00200   continue
c  00100 continue
c        
c        maxang = maxang*(maxang+1)/2
c        maxg = maxang**4
c        maxshltypei = maxshltypei-1
c        maxshltypej = maxshltypej-1
c        maxshltypek = maxshltypei
c        maxshltypel = maxshltypej
c        maxprimk = maxprimi
c        maxpriml = maxprimj
c        memdum = 4 000 000
c        call hf2(c,ex,cspd,maxprimi,maxshltypei,
c       &       c,ex,cspd,maxprimj,maxshltypej,
c       &       c,ex,cspd,maxprimk,maxshltypek,
c       &       c,ex,cspd,maxpriml,maxshltypel,
c       &       ex,memdum,.true.)
c        mem2 = memdum
c        write(6,*)' (prim,L) ',maxprimi,maxshltypei,
c       &       maxprimj,maxshltypej,
c       &       maxprimk,maxshltypek,
c       &       maxpriml,maxshltypel
c        
c        write(6,'(a,i8)')' apx_mem_2: memory mem2 = ',mem2
c        write(6,'(a,i8)')' apx_mem_2: memory maxg = ',maxg
c        end
c        subroutine apx_mem_1(mem1,max1e)
c        implicit none
c        include 'int.h'
c  c:passed
c        integer mem1, max1e
c  c:local
c        integer ish,jsh, ish_type, jsh_type, ish_ng, jsh_ng
c        integer ish_size, jsh_size
c        integer maxprimi, maxshltypei, maxprimj, maxshltypej
c        integer mcurrent, mtest
c        integer memdum
c        integer maxang
c  c
c  
c        maxprimi    = -1
c        maxshltypei = -1
c        maxprimj    = -1
c        maxshltypej = -1
c        mcurrent    =  0
c        maxang      = -1
c  
c        do 00100 ish = 1,nshell
c          ish_type = ktype(ish)
c          ish_ng   = kng(ish)
c  c        ish_size = ish_ng*ish_type*(ish_type+1)/2
c          ish_size = ish_ng*ish_type
c          maxang   = max(maxang,ish_type)
c  
c          do 00200 jsh = 1,ish
c            jsh_type = ktype(jsh)
c            jsh_ng   = kng(jsh)
c  c          jsh_size = jsh_ng*jsh_type*(jsh_type+1)/2
c            jsh_size = jsh_ng*jsh_type
c  
c            mtest = ish_size + jsh_size
c  
c            if (mtest .gt. mcurrent) then
c              mcurrent    = mtest
c              maxprimi    = ish_ng
c              maxshltypei = ish_type
c              maxprimj    = jsh_ng
c              maxshltypej = jsh_type
c            endif
c  00200   continue
c  00100 continue
c  
c        max1e = 3*maxang*maxang*(maxang+1)*(maxang+1)/4
c        maxshltypei = maxshltypei - 1
c        maxshltypej = maxshltypej - 1
c        memdum = 2000000
c        call hf1(c,zan,nat,c,ex,cspd,maxprimi,maxshltypei,
c       &       c,ex,cspd,maxprimj,maxshltypej,ex,memdum,.true.)
c        mem1 = memdum
c        write(6,*)' mip=',maxprimi,' mit=',maxshltypei,
c       &       ' mjp=',maxprimj,' mjt=',maxshltypej
c        write(6,'(a,i8)')' apx_mem_1: memory mem1  = ',mem1
c        write(6,'(a,i8)')' apx_mem_1: memory max1e = ',max1e
c        end
c        subroutine v_apx_mem_1()
c        implicit none
c        include 'int.h'
c  
c  c:local
c        integer ish
c        integer maxprim, maxshltype
c        integer memdum
c        integer maxnprimg
c  
c        real*8 time1,time2
c  
c  c
c        call second(time1)
c  
c        maxprim = -1
c        maxshltype = -1
c  
c        do 00100 ish = 1,nshell
c  
c            maxprim = max(maxprim,kng(ish))
c  c:1:didnt work          maxshltype = max(maxshltype,ktype(ish))
c            if (maxshltype.lt.ktype(ish)) then
c              maxshltype = ktype(ish)
c              maxnprimg  = kng(ish)
c            endif
c  
c  00100 continue
c        maxshltype = maxshltype - 1
c  
c        memdum = 2000000
c        call hf1(c,zan,nat,c,ex,cspd,maxprim,maxshltype,
c       &       c,ex,cspd,maxprim,maxshltype,ex,memdum,.true.)
c  
c        if (maxprim.ne.maxnprimg)memdum = memdum/(2*maxprim)
c        call second(time2)
c        write(6,*)' mip=',maxprim,' mit=',maxshltype,maxnprimg
c        write(6,'(a,i8)')' v_apx_mem_1: memory = ',memdum
c        write(6,'(a,f10.4)')' v_apx_mem_1: ',(time2-time1),' seconds.'
c      end
c        subroutine apx_mem_2(mem2,maxg)
c        implicit none
c        include 'int.h'
c  c:passed
c        integer mem2, maxg
c  c:local
c        integer ish,jsh,ksh,lsh,lend
c        integer ish_type,jsh_type,ksh_type,lsh_type
c        integer ish_ng,jsh_ng,ksh_ng,lsh_ng
c        integer ish_size,jsh_size,ksh_size,lsh_size
c        integer maxprimi,maxprimj,maxprimk,maxpriml
c        integer maxshltypei,maxshltypej,maxshltypek,maxshltypel
c        integer mcurrentij, mtestij, mcurrentkl, mtestkl
c        integer memdum, maxgv
c  c
c        maxprimi    = -1
c        maxprimj    = -1
c        maxprimk    = -1
c        maxpriml    = -1
c        maxshltypei = -1
c        maxshltypej = -1
c        maxshltypek = -1
c        maxshltypel = -1
c        mcurrentij  = 0
c        mcurrentkl  = 0
c        maxg        = 0
c  c
c        do 00100 ish = 1,nshell
c          ish_type = ktype(ish)
c          ish_ng   = kng(ish)
c          ish_size = ish_type*(ish_type+1)/2
c  
c          do 00200 jsh = 1,ish
c            jsh_type = ktype(jsh)
c            jsh_ng   = kng(jsh)
c            jsh_size = jsh_type*(jsh_type+1)/2
c  
c            do 00300 ksh = 1,ish
c              ksh_type = ktype(ksh)
c              ksh_ng   = kng(ksh)
c              ksh_size = ksh_type*(ksh_type+1)/2
c              if (ish.eq.ksh) then
c                lend = jsh
c              else
c                lend = ksh
c              endif
c  
c              do 00400 lsh = 1,lend
c                lsh_type = ktype(lsh)
c                lsh_ng   = kng(lsh)
c                lsh_size = lsh_type*(lsh_type+1)/2
c  
c                mtestij = ish_ng*ish_size + jsh_ng*jsh_size
c                if (mtestij .gt. mcurrentij) then
c                  mcurrentij = mtestij
c                  maxprimi    = ish_ng
c                  maxprimj    = jsh_ng
c                  maxshltypei = ish_type
c                  maxshltypej = jsh_type
c                endif
c  
c                mtestkl = ksh_ng*ksh_size + lsh_ng*lsh_size
c                if (mtestkl .gt. mcurrentkl) then
c                  mcurrentkl = mtestkl
c                  maxprimk    = ksh_ng
c                  maxpriml    = lsh_ng
c                  maxshltypek = ksh_type
c                  maxshltypel = lsh_type
c                endif
c  
c                maxgv = ish_size*jsh_size*ksh_size*lsh_size
c                maxg = max(maxg,maxgv)
c                
c  00400       continue
c  00300     continue
c  00200   continue
c  00100 continue
c        maxshltypei = maxshltypei-1
c        maxshltypej = maxshltypej-1
c        maxshltypek = maxshltypek-1
c        maxshltypel = maxshltypel-1
c        memdum = 4 000 000
c        call hf2(c,ex,cspd,maxprimi,maxshltypei,
c       &       c,ex,cspd,maxprimj,maxshltypej,
c       &       c,ex,cspd,maxprimk,maxshltypek,
c       &       c,ex,cspd,maxpriml,maxshltypel,
c       &       ex,memdum,.true.)
c        mem2 = memdum
c  c        write(6,*)' (prim,L) ',maxprimi,maxshltypei,
c  c       &       maxprimj,maxshltypej,
c  c       &       maxprimk,maxshltypek,
c  c       &       maxpriml,maxshltypel
c  
c        write(6,'(a,i8)')' apx_mem_2: memory mem2 = ',mem2
c        write(6,'(a,i8)')' apx_mem_2: memory maxg = ',maxg
c        end
c        subroutine apx_mem_2(mem2,maxg)
c        implicit none
c        include 'int.h'
c  c:passed
c        integer mem2, maxg
c  c:local
c        integer ish,jsh,ksh,lsh,lend
c        integer ish_type,jsh_type,ksh_type,lsh_type
c        integer ish_ng,jsh_ng,ksh_ng,lsh_ng
c        integer ish_size,jsh_size,ksh_size,lsh_size
c        integer maxprimi,maxprimj,maxprimk,maxpriml
c        integer maxshltypei,maxshltypej,maxshltypek,maxshltypel
c        integer mcurrentij, mtestij, mcurrentkl, mtestkl
c        integer memdum, maxang
c        integer i,ishellsize
c  c
c        ishellsize(i) = i*(i+1)/2
c  c
c        maxprimi    = -1
c        maxprimj    = -1
c        maxprimk    = -1
c        maxpriml    = -1
c        maxshltypei = -1
c        maxshltypej = -1
c        maxshltypek = -1
c        maxshltypel = -1
c        mcurrentij  =  0
c        mcurrentkl  =  0
c        maxg        =  0
c        maxang      = -1
c  c
c        do 00100 ish = 1,nshell
c          ish_type = ktype(ish)
c          ish_ng   = kng(ish)
c          ish_size = ish_ng*ishellsize(ish_type)
c          maxang   = max(maxang,ish_type)
c  
c          do 00200 jsh = 1,ish
c            jsh_type = ktype(jsh)
c            jsh_ng   = kng(jsh)
c            jsh_size = jsh_ng*ishellsize(jsh_type)
c  
c            do 00300 ksh = 1,ish
c              ksh_type = ktype(ksh)
c              ksh_ng   = kng(ksh)
c              ksh_size = ksh_ng*ishellsize(ksh_type)
c              if (ish.eq.ksh) then
c                lend = jsh
c              else
c                lend = ksh
c              endif
c  
c              do 00400 lsh = 1,lend
c                lsh_type = ktype(lsh)
c                lsh_ng   = kng(lsh)
c                lsh_size = lsh_ng*ishellsize(lsh_type)
c  
c                mtestij = ish_size + jsh_size + ksh_size + lsh_size
c                if (mtestij .gt. mcurrentij) then
c                  mcurrentij = mtestij
c                  maxprimi    = ish_ng
c                  maxprimj    = jsh_ng
c                  maxshltypei = ish_type
c                  maxshltypej = jsh_type
c                  maxprimk    = ksh_ng
c                  maxpriml    = lsh_ng
c                  maxshltypek = ksh_type
c                  maxshltypel = lsh_type
c                endif
c  
c  00400       continue
c  00300     continue
c  00200   continue
c  00100 continue
c        maxang = ishellsize(maxang)
c        maxg   = maxang**4
c        maxshltypei = maxshltypei-1
c        maxshltypej = maxshltypej-1
c        maxshltypek = maxshltypek-1
c        maxshltypel = maxshltypel-1
c        memdum = 4 000 000
c        call hf2(c,ex,cspd,maxprimi,maxshltypei,
c       &       c,ex,cspd,maxprimj,maxshltypej,
c       &       c,ex,cspd,maxprimk,maxshltypek,
c       &       c,ex,cspd,maxpriml,maxshltypel,
c       &       ex,memdum,.true.)
c        mem2 = memdum
c        write(6,*)' (prim,L) ',maxprimi,maxshltypei,
c       &       maxprimj,maxshltypej,
c       &       maxprimk,maxshltypek,
c       &       maxpriml,maxshltypel
c  
c        write(6,'(a,i8)')' apx_mem_2: memory mem2 = ',mem2
c        write(6,'(a,i8)')' apx_mem_2: memory maxg = ',maxg
c        end
