      Subroutine nmcoef(z,cc,l,np)
c
c$Id: nmcoef.f,v 1.1 1993/08/31 01:27:11 gg502 Exp $
c
      Implicit real*8 (a-h,o-z)
      Implicit integer (i-n)

      Parameter (PI=3.1415926535898D0)

      Dimension z(np),cc(np)
c
c The normalization of the Gaussian primitives and contractions is based
c on the value of this integral
c
c   /   2i           2                      / PI \ 1/2  /  1 \ i
c   |  x   exp( - p x  ) dx  =  (2i - 1)!! | ---- |    | ---- |
c   /                                       \ p  /      \ 2p /
c
c However, the double factorial is not included in the normalization. Thus,
c the normalization depends only on the angular momentum (l = i+j+k) and 
c not on the individual angular momentum indices (i,j,k).
c 
c l is the actual angular momentum: e.g., 0=s, 1=p, 2=d, ....
c
c******************************************************************************

c Normalize the primitives.

      do 10 n = 1,np
       cc(n) = cc(n)*((2.D0*z(n)/PI)**0.75D0)*(4.D0*z(n))**(0.5D0*l)
   10 continue

c Normalize the contractions.

      sum = 0.D0
      do 20 n1 = 1,np
      do 20 n2 = 1,np
       S = ( (PI/(z(n1) + z(n2)))**1.5D0 )/( (2.D0*(z(n1) + z(n2)))**l )
       sum = sum + cc(n1)*cc(n2)*S
   20 continue

      f = 1/sqrt(sum)
      do 30 n = 1,np
       cc(n) = cc(n)*f
   30 continue

      end
