      subroutine swshell(ienv,schwarz,nshtri,swmax,
     &       eri,ii,jj,kk,ll,scratch,lscratch)
c
c$Id: swshell.f,v 1.1 1993/08/31 01:27:14 gg502 Exp $
c

c
cDescription:  Compute integrals needed for schwartz inequality (SI)
c
cArguments (I=input,O=output,S=scratch):
cI:      ienv         integral environment pointer
cO:      schwarz(*)   array to hold SI values
cI:      nshtri       triangle of shells (size of schwarz)
cO:      swmax        maximum
cS:      eri(*)       array for integrals from API
cS:      xx(*)        x=i,j,k,l, arrays for integral basis function labels 
c                     not used in this routine.
cS:      scratch(*)   scratch for integral computation
cI:      lscratch     length of scratch array.
      implicit none
      integer ienv,nshtri,lscratch
      real*8 schwarz(nshtri),swmax
      real*8 eri(*),scratch(lscratch)
      integer ii(*),jj(*),kk(*),ll(*)
c:local
      integer isym2,i,j,nints,ish,jsh,nshell,iint,iish
      real*8 xval
c
c Statement function to compute canonical i,j index
c
      isym2(i,j)=(max(i,j)*(max(i,j)-1))/2 + min(i,j)
c
c check that environment is okay (pointer later a call to intenv)
c
      if (ienv.ne.565) then
        write(6,*)' environment not set call intinit first '
        stop ' env error '
      endif

      call gnshell(ienv,nshell)

      do 00300 ish = 1, nshell
        do 00400 jsh = 1, ish

c. . . . . . . ! (.true.  argument) get integrals with canonicalization
c. . . . . . . ! (.false. argument) get integrals without zero's eliminated
          call twoint(ienv,ish,jsh,ish,jsh,
     &           eri,ii,jj,kk,ll,nints,
     &           scratch,lscratch,.true.,.false.)

c. . . . . . . . . . . . . . . . ! get maximum integral value
          xval = 0.0d00
          do 00500 iint = 1,nints
            xval = max(xval,abs(eri(iint)))
00500     continue

          schwarz(isym2(ish,jsh))=sqrt(xval)

00400   continue
00300 continue

c. . . . . . . . . . . . . . . . . ! sort out maximum value
      swmax = schwarz(1)
      do 00100 iish=2,nshtri
        swmax = max(swmax,schwarz(iish))
00100 continue
      
      end


      
