C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     compute -- perform the actual calculation
C
C SYNOPSIS
      Subroutine Compute( NShell, NAOBF, NOcc, C_Hdl,
     $     F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
      Implicit NONE
      Integer NShell, NAOBF, NOcc, C_Hdl, F_Hdl, FAO_Hdl,
     $   S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl
C
C REVISION
C     $Id: compute.F,v 1.3 1993/11/08 19:49:26 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "exepath.fh"
C
C     ******************************************
C     * The most simple-minded implementations *
C     ******************************************
C
      If ( ExePath .eq. 'TOY1' ) then
         Call Toy1( NShell, NAOBF, NOcc, C_Hdl,
     $      F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl)
      EndIf
C
C     ************************************
C     * A less brain-dead implementation *
C     ************************************
C
      If ( ExePath .eq. 'TOY2' ) then
         Call Toy2( NAOBF, NOcc, C_Hdl,
     $      F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
      EndIf
C
C     ***************************************
C     * A first cut parallel implementation *
C     ***************************************
C
      If ( ExePath .eq. 'PAR1' ) then
         Call Par1( NAOBF, NOcc, C_Hdl,
     $      F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
      EndIf
C
C     *****************************
C     * Improved parallel version *
C     *****************************
C
      If ( ExePath .eq. 'PAR2' ) then
         Call Par2( NAOBF, NOcc, C_Hdl,
     $      F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
      EndIf
C
C     ****************************
C     * Another parallel version *
C     ****************************
C
      If ( ExePath .eq. 'PAR3' ) then
         Call Par3( NAOBF, NOcc, C_Hdl,
     $      F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
      EndIf
C
      Return
      End
