C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     estmem -- estimate memory requirements
C
C SYNOPSIS
      Subroutine EstMem( Stack_Mem, Heap_Mem, NAOBF, NMOBF, NFokOp,
     $     NOccMO)
      Implicit NONE
      Integer Stack_Mem, Heap_Mem, NAOBF, NMOBF, NFokOp, NOccMO
C
C ARGUMENTS
C     Stack_Mem  Estimated needs for stack-managed memory (OUT)
C     Heap_Mem   Estimated needs for heap-managed memory (OUT)
C
C REVISION
C     $Id: estmem.F,v 1.3 1993/11/08 19:49:27 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "stdio.fh"
C These guys are included in integral_api.fh at the moment
C #include "mafdecls.h"
C #include "mafuncs.fh"
#include "integral_api.fh"
#include "int.h"
#include "exepath.fh"
C
C LOCAL VARIABLES
      Integer Integral_Mem, Setup_Mem, Energy_Mem, Scratch_Mem
C
C     Based on this information we can now estimate the required
C     scratch space and integral buffers.
C
      Setup_Mem = 7 * NAOBF * NAOBF
C
      If ( ExePath .eq. 'PAR1' .OR. ExePath .eq. 'PAR3' ) then
         Integral_Mem = Mem_TwoInt(MT_Dbl)
      ElseIf ( ExePath .eq. 'PAR2' ) then
         Integral_Mem = Mem_TwoInt_At(MT_Dbl)
      EndIf
C
      Energy_Mem = 3 * NAOBF * NAOBF * NOccMO * (NOccMO+1)/2
C
C     I think the largest simultaneous usage is 2 NAOBF*NAOBF + 2 * NAOBF
C
      Scratch_Mem = 4 * NAOBF * NAOBF
C
C     Add everything up -- put it all in stack.  Convert it to
C     MT_BYTE because that's what the main program is expecting.
C
      Stack_Mem = Setup_Mem + Integral_Mem + Energy_Mem + Scratch_Mem
      Stack_Mem = MA_SizeOf(MT_DBL, Stack_Mem, MT_BYTE)
C
      Heap_Mem = 0
C
      Return
      End
