C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     firstin -- Collect basic inputs needed to estimate memory usage.
C
C SYNOPSIS
      Subroutine FirstIn( TotMem, NShell, NAOBF, NMOBF, NFokOp, NOccMO)
      Implicit NONE
      Integer TotMem, NShell, NAOBF, NMOBF, NFokOp, NOccMO
C
C ARGUMENTS
C     TotMem  Total memory to be allocated (OUT)
C     NShell  Number of shells in AO basis (OUT)
C     NAOBF   Number of AO basis functions (OUT)
C     NMOBF   Number of MO basis functions (OUT)
C     NFokOp  Number of Fock operators (OUT)
C     NOccMO  Number of occupied molecular orbitals (OUT)
C
C REVISION
C     $Id: firstin.F,v 1.3 1993/10/03 10:54:41 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "stdio.fh"
#include "denmat_iostuff.fh"
#include "denmat_funcs.fh"
C
C CONSTANTS
      Integer DefMem
      Parameter (DefMem = 1 * 1024 * 1024)
C
C LOCAL VARIABLES
      Integer ISCFTyp, IEnd
      Double Precision ENuc, ERef
C
      Read( LuIn, FMT=*, END=8000, ERR=8000 ) TotMem
      Goto 8100
C
C     No user input -- use default.
C
 8000 Continue
      TotMem = DefMem
C
C     Get some information from the environment
C
 8100 Call IWReadW( ICk, NShell, 1, 103, IEnd)
      Call IWReadW( ICk, NAOBF, 1, 105, IEnd)
      NMOBF = NAOBF
      Call IWReadW( ICk, ISCFTyp, 1, 111, IEnd)
      NFokOp = ISCFTyp + 1
      Call IWReadW( ICk, NOccMO, 1, 115, IEnd)
C
      Call DGetArray( ICk, ENuc, 1, 355)
      Call DGetArray( ICk, ERef, 1, 361)
C
      Write (LuOut, 9000 ) NAOBF, NMOBF, NOccMO, NFokOp
      Write (LuOut, 9010 ) ENuc, ERef
 9000 Format( 1X, 'Size of AO basis:              ', I6,
     $       /1X, 'Size of MO basis:              ', I6,
     $       /1X, 'Number of occupied orbitals:   ', I6,
     $       /1X, 'Number of Fock operators:      ', I6)
 9010 Format( 1X, 'Nuclear repulsion energy:      ', F30.15,
     $       /1X, 'Reference wavefunction energy: ', F30.15)
      Return
      End
