C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     initialize -- Perform any initialization requiring some knowledge
C     of the input
C
C SYNOPSIS
      Subroutine Initialize(StkMem, HeapMem)
      Implicit NONE
      Integer StkMem, HeapMem
C
C REVISION
C     $Id: initialize.F,v 1.2 1993/11/08 19:49:28 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C#include "mafdecls.h"  ! already included by integral_api
#include "integral_api.fh"
#include "int.h"
#include "stdio.fh"
C LOCAL VARIABLES
      Logical LResult
      Double precision NucRep
C
C     Setup the memory allocator
C
      If ( .NOT. MA_Initialize( MT_BYTE, StkMem, HeapMem) ) then
         Write( LuErr, *) ' Failed to allocate requested memory.'
         Stop
      EndIf
C
C     While developing code, we want to know immediately about any errors.
C     Note:  These return the previous setting of the flag, not an
C     actual status.
C
      LResult = MA_Set_Hard_Fail( .TRUE. )
      LResult = MA_Set_Auto_Verify( .TRUE. )
C
C     Initialize the global array facilities.  Requires MA be running.
C
      Call GA_Initialize
C
C     Initialize integral package. Requires MA be running.
C
      If ( .NOT. Init_Integrals() ) then
         Write( LuErr, *) ' Failed to initialize integral package'
         Stop
      EndIf
C
C     Compute nuclear repulsion energy using our integral environment,
C     so that we can verify that it matched the SCF's geometry.
C     (Given DENMAT's current input deck, it is far too easy to have
C     the SCF and E(2) run at different geometries by mistake.)
C     The data required to feed CNRepE comes from the /IntShit/ common
C     of the integral package.
C
      Call CNRepE( C, ZAN, NucRep, NAt)
      Write (LuOut, 9010) NucRep
 9010 Format( 1X, '--- For current VLE2 integral environment ---',
     $     /1X, 'Nuclear repulsion energy:      ', F30.15)
C
      Return
      End
