      subroutine orthv2(n, m, v, s, work1, work2)
      implicit none
      integer n, m
      double precision v(n,m), s(n,n), work1(n), work2(n)
c
      integer i
      double precision a, ddot
c     
c     orthonormalize vectors (v) in place over metric (s)
c     
c     v = matrix of column vectors
c     s = full square metric matrix
c
c     note ... is not suitable for high precision or if the
c              input vectors are close to linear dependence
c
c          ... assumes that the metric is symmetric
c     
c     normalize vector one
c
      call dgemv('n',n,n,1.0d0,s,n,v(1,1),1,0.0d0,work1,1)
      a = ddot(n, work1, 1, v(1,1), 1)
      call dscal(n, 1.0d0/dsqrt(a), v(1,1), 1)
c
      do 10 i = 2, m
c
c     orthog vector i to vectors j=1,...,i-1
c
         call dgemv('n',n,n,1.0d0,s,n,v(1,i),1,0.0d0,work1,1)
         call dgemv('t',n,i-1,1.0d0,v,n,work1,1,0.0d0,work2,1)
         call dgemv('n',n,i-1,-1.0d0,v,n,work2,1,1.0d0,v(1,i),1)
c
c     normalize vector i
c
         call dgemv('n',n,n,1.0d0,s,n,v(1,i),1,0.0d0,work1,1)
         a = ddot(n, work1, 1, v(1,i), 1)
         call dscal(n, 1.0d0/dsqrt(a), v(1,i), 1)
 10   continue
c
      end
