C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     detriangularize -- Convert from a triangular index, IJ = I(I-1)/2 + J,
C     to separate I and J, I >= J.
C
C SYNOPSIS
      Subroutine Detriangularize( IJ, I, J)
      Implicit NONE
      Integer IJ, I, J
C
C ARGUMENTS
C     IJ      Triangular index, IJ = I(I-1)/2 + J [IN]
C     I       Row index, I >= J. [OUT]
C     J       Column index. [OUT]
C
C DESCRIPTION
C     Extracts I and J from the triangular index IJ = I(I-1)/2 + J.
C
C REVISION
C     $Id: detriangularize.f,v 1.1 1993/09/18 23:47:51 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      I = Int( Sqrt( Float( 2 * IJ ) ) + 0.5 )
      J = IJ - I * (I-1) / 2
      Return
      End
