C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     mk_dij_shqt -- Make the "density" Dij blocks corresponding to a
C     single shell quartet
C
C SYNOPSIS
      Subroutine Mk_Dij_ShQt(N, C, I, J, Shell1, Shell2, Shell3,
     $   Shell4, D, FPMO, FPAO)
      Implicit NONE
      Integer N, I, J, Shell1, Shell2, Shell3, Shell4
      Double precision FPMO, FPAO
      Double precision C(N, *), D(N, N)
C
C ARGUMENTS
C DESCRIPTION
C REVISION
C     $Id: mk_dij_shqt.F,v 1.1 1993/11/08 19:49:46 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "numerical_constants.fh"
C LOCAL VARIABLES
      Integer Len1, Len2, Len3, Len4
      Integer Begin1, Begin2, Begin3, Begin4
      Integer End1, End2, End3, End4
C
C     This is used only to match arguments with what RJH is writing.
C     Probably eventually it will be passed in or something.
C
      Integer Basis
C
C     Find out what range of basis functions these shells correspond to.
C
      Call GTO_Sh_to_BF( Basis, Shell1, Begin1, End1)
      Call GTO_Sh_to_BF( Basis, Shell2, Begin2, End2)
      Call GTO_Sh_to_BF( Basis, Shell3, Begin3, End3)
      Call GTO_Sh_to_BF( Basis, Shell4, Begin4, End4)
      Len1 = End1 - Begin1 + 1
      Len2 = End2 - Begin2 + 1
      Len3 = End3 - Begin3 + 1
      Len4 = End4 - Begin4 + 1
C
C     Work that will be done
C
      FPMO = 2 * Len1 * Len3 + 2 * Len1 * Len4 + 2 * Len2 * Len3
     $   + 2 * Len2 * Len4
      FPAO = 2 * Len1 * Len3 + 2 * Len1 * Len4 + 2 * Len2 * Len3
     $   + 2 * Len2 * Len4
C     
C     Because D_{ij} is not symmetric, we have not four, but
C     eight different blocks to build.
C
      Call DGEMM('N','T', Len1, Len3, 1,
     $   FP_One, C(Begin1, I), N, C(Begin3, J), N,
     $   FP_Zero, D(Begin1, Begin3), N)
C
      Call DGEMM('N','T', Len1, Len4, 1,
     $   FP_One, C(Begin1, I), N, C(Begin4, J), N,
     $   FP_Zero, D(Begin1, Begin4), N)
C
      Call DGEMM('N','T', Len2, Len3, 1,
     $   FP_One, C(Begin2, I), N, C(Begin3, J), N,
     $   FP_Zero, D(Begin2, Begin3), N)
C
      Call DGEMM('N','T', Len2, Len4, 1,
     $   FP_One, C(Begin2, I), N, C(Begin4, J), N,
     $   FP_Zero, D(Begin2, Begin4), N)
C
C
C
      Call DGEMM('N','T', Len3, Len1, 1,
     $   FP_One, C(Begin3, I), N, C(Begin1, J), N,
     $   FP_Zero, D(Begin3, Begin1), N)
C
      Call DGEMM('N','T', Len3, Len2, 1,
     $   FP_One, C(Begin3, I), N, C(Begin2, J), N,
     $   FP_Zero, D(Begin3, Begin2), N)
C
      Call DGEMM('N','T', Len4, Len1, 1,
     $   FP_One, C(Begin4, I), N, C(Begin1, J), N,
     $   FP_Zero, D(Begin4, Begin1), N)
C
      Call DGEMM('N','T', Len4, Len2, 1,
     $   FP_One, C(Begin4, I), N, C(Begin2, J), N,
     $   FP_Zero, D(Begin4, Begin2), N)
C
      Return
      End
