C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     par2_int_into_kop -- Contract integrals with "density" to form 
C     exchange operators
C
C SYNOPSIS
      Subroutine Par2_Int_into_KOp(NInt, Idx1, Idx2, Idx3, Idx4, ERI,
     $   NBF, NOp, D, KOp, FPMO, FPAO)
      Implicit NONE
      Integer NInt, NBF, NOp
      Double precision FPMO, FPAO
      Integer Idx1( NInt ), Idx2( NInt ), Idx3( NInt ), Idx4( NInt )
      Double precision ERI( NInt), D(NBF, NBF, NOp), KOp(NBF, NBF, NOp)
C
C ARGUMENTS
C DESCRIPTION
C REVISION
C     $Id: par2_int_into_kop.f,v 1.1 1993/11/08 19:49:59 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer N, IJ, P, Q, R, S
C     
C     Use this "density" to produce the IJ exchange 
C     operator.  This requires 8 FP multiply+adds
C     per integral.
C     
      FPMO = 8 * NInt * NOp
      FPAO = 8 * NInt * NOp
C     
      Do IJ = 1, NOp
         Do N = 1, NInt
            P = Idx1( N )
            Q = Idx2( N )
            R = Idx3( N )
            S = Idx4( N )
C           
C           Consider all permutations of the indices
C           for possible contributions to KOp
C           
            KOp(P, R, IJ) = KOp(P, R, IJ) + D(Q, S, IJ) * ERI( N ) 
C           
            KOp(Q, R, IJ) = KOp(Q, R, IJ) + D(P, S, IJ) * ERI( N ) 
C           
            KOp(P, S, IJ) = KOp(P, S, IJ) + D(Q, R, IJ) * ERI( N ) 
C           
            KOp(Q, S, IJ) = KOp(Q, S, IJ) + D(P, R, IJ) * ERI( N ) 
C           
C           
C           
            KOp(R, P, IJ) = KOp(R, P, IJ) + D(S, Q, IJ) * ERI( N ) 
C           
            KOp(S, P, IJ) = KOp(S, P, IJ) + D(R, Q, IJ) * ERI( N ) 
C           
            KOp(R, Q, IJ) = KOp(R, Q, IJ) + D(S, P, IJ) * ERI( N ) 
C           
            KOp(S, Q, IJ) = KOp(S, Q, IJ) + D(R, P, IJ) * ERI( N ) 
C           
         EndDo                  ! N
      EndDo ! IJ
C
      Return
      End
