C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     par3_create_int_pool -- Create the data structures for the integral
C     pool in the global array space
C
C SYNOPSIS
      Subroutine Par3_Create_Int_Pool(MxNInt, Buf_per_proc)
      Implicit NONE
      Integer MxNInt, Buf_per_Proc
C
C REVISION
C     $Id: par3_create_int_pool.F,v 1.1 1993/11/08 19:50:11 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "mafdecls.h"
#include "global.h"
#include "int_pool_private.fh"
C LOCAL VARIABLES
      Logical LResult
      Integer NProc
C
      NProc = GA_NNodes()
C
      LResult = GA_Create( MT_Dbl, MxNInt, Buf_per_Proc * NProc,
     $   'Pool space for ERIs', MxNInt, Buf_per_Proc, ERIBuf_Hdl)
C
      LResult = GA_Create( MT_Int, 4*MxNInt, Buf_per_Proc * NProc,
     $   'Pool space for indices', 4*MxNInt, Buf_per_Proc, IdxBuf_Hdl)
C
c$$$      LResult = GA_Create( MT_Int, 1, Buf_Per_Proc * NProc,
c$$$     $   'Pool space for number of integrals', 1, Buf_per_proc,
c$$$     $   NBuf_Hdl)
c$$$C
      LResult = GA_Create( MT_Int, Buf_per_proc * NProc, NProc,
     $   'Pool control info', Buf_per_Proc * NProc, 1, BufCtl_Hdl)
C
      LResult = GA_Create( MT_Int, Buf_per_proc * NProc, 1,
     $   'Pool integral creation done', Buf_per_proc, 1, Done_Hdl)
C
C     Zeros in the control array indicates nothing to read.
C
      Call GA_Zero( BufCtl_Hdl)
C
C     Similarly, indicate that every buffer is ready for reuse
C
      Call GA_Zero( Done_Hdl )
C
      Return
      End
