C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     par3_grab_buffer -- Obtain a free buffer in the integral pool
C
C SYNOPSIS
      Integer Function Par3_Grab_Buffer( Need, NProc, Dump)
      Implicit NONE
      Integer NProc, Dump
      Integer Need(NProc)
C
C REVISION
C     $Id: par3_grab_buffer.F,v 1.1 1993/11/08 19:50:20 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "global.h"
#include "int_pool_private.fh"
C FUNCTIONS
      Integer IASum
      External IASUM
C
C LOCAL VARIABLES
      Integer LoBuf, HiBuf, LoData, HiData, Junk, Buf, InUse, NLeft
C
C     Determine which buffers of the pool we hold
C
      Call GA_Distribution( ERIBuf_Hdl, GA_NodeID(), LoData, HiData,
     $   LoBuf, HiBuf, Junk)
c$$$      Write (0, '(I5, A, 4I5)')
c$$$     $   GA_NodeID(), ' has ', LoBuf, HiBuf
C
C     Loop through our buffers and check which have been processed by
C     everyone that wants them.
C
      Do Buf = LoBuf, HiBuf
C
         Call GA_Get( Done_Hdl,    Buf,   Buf, 1, 1, InUse, 1)
c$$$         Call GA_Get( Done_Hdl,    Buf,   Buf, 1, 1, NLeft, 1)
c$$$C
c$$$C        Get this slice of the data structure
c$$$C
c$$$         Call GA_Get( BufCtl_Hdl,    Buf,   Buf, 1, NProc, Need, 1)
c$$$C
c$$$C        Check for any non-zero entries
c$$$C
c$$$         InUse = IASum( NProc, Need, 1)
c$$$C
c$$$         If ( InUse .eq. 0 .AND. NLeft .ne. 0) then
c$$$            Write (0, *) ' Don''t match: ', InUse, NLeft
c$$$            Call FFFlush(0)
c$$$         EndIf
         If ( Dump .gt. 0 .AND. Mod( Dump, 100) .eq. 0 ) then
            Write (0, '(I5, A,I5, A, I5, A)' )
     $         GA_NodeID(), ': Buffer ', Buf, ' needs ', InUse,
     $         ' readers.'
c$$$            Write (0, '(39I2)') Need
            Call FFFlush(0)
         EndIf
C
         If ( InUse .eq. 0) then
            Par3_Grab_Buffer = Buf
            Return
         EndIf
C
      EndDo
C
      Par3_Grab_Buffer = 0
C
      Return
      End
