C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     Par3_int_into_kop -- Contract integrals with "density" to form 
C     exchange operators
C
C SYNOPSIS
      Subroutine Par3_Int_into_KOp(NInt, Idx1, Idx2, Idx3, Idx4, ERI,
     $   NBF, NOp, D, KOp, RBlkSz, CBlkSz, NProc_Row, Me,
     $   OrigR, OrigC, RDim, CDim, FPMO, FPAO)
      Implicit NONE
      Integer NInt, NBF, NOp, RDim, CDim, NProc_Row, Me, OrigR, OrigC,
     $   RBlkSz, CBlkSz
      Double precision FPMO, FPAO
      Integer Idx1( NInt ), Idx2( NInt ), Idx3( NInt ), Idx4( NInt )
      Double precision ERI( NInt), D(NBF, NBF, NOp),
     $   KOp(OrigR:OrigR+RDim-1, OrigC:OrigC+CDim-1, NOp)
c$$$     $   KOp(RDim, CDim, NOp)
C
C ARGUMENTS
C DESCRIPTION
C REVISION
C     $Id: par3_int_into_kop.f,v 1.1 1993/11/08 19:50:21 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C LOCAL VARIABLES
      Integer N, IJ, P, Q, R, S
C
C STATEMENT FUNCTIONS
      Integer Which_Proc
      Logical HaveKOp
C
      Which_Proc( P, Q ) = ( P / RBlkSz ) + NProc_Row * ( Q / CBlkSz )
C
      HaveKOp( P, Q) = ( P .ge. OrigR .AND. P .le. OrigR+RDim-1 )
     $   .AND. ( Q .ge. OrigC .AND. Q .le. OrigC+CDim-1 )
C     
C     Use this "density" to produce the IJ exchange 
C     operator.  This requires 8 FP multiply+adds
C     per integral.
C     
      FPMO = 8 * NInt * NOp
      FPAO = 8 * NInt * NOp
C     
      Do IJ = 1, NOp
         Do N = 1, NInt
            P = Idx1( N )
            Q = Idx2( N )
            R = Idx3( N )
            S = Idx4( N )
C           
C           Consider all permutations of the indices
C           for possible contributions to KOp
C           
c$$$            If ( Which_Proc( P, R) .eq. Me ) then
            If ( HaveKOp( P, R) ) then
               KOp(P, R, IJ) = KOp(P, R, IJ) + D(Q, S, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', P, R, IJ, KOp(P,R,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( Q, R) .eq. Me ) then
            If ( HaveKOp( Q, R) ) then
               KOp(Q, R, IJ) = KOp(Q, R, IJ) + D(P, S, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', Q, R, IJ, KOp(Q,R,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( P, S) .eq. Me ) then
            If ( HaveKOp( P, S) ) then
               KOp(P, S, IJ) = KOp(P, S, IJ) + D(Q, R, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', P, S, IJ, KOp(P,S,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( Q, S) .eq. Me ) then
            If ( HaveKOp( Q, S) ) then
               KOp(Q, S, IJ) = KOp(Q, S, IJ) + D(P, R, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', Q, S, IJ, KOp(Q,S,IJ)
            EndIf
C           
C           
C           
c$$$            If ( Which_Proc( R, P) .eq. Me ) then
            If ( HaveKOp( R, P) ) then
               KOp(R, P, IJ) = KOp(R, P, IJ) + D(S, Q, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', R, P, IJ, KOp(R,P,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( S, P) .eq. Me ) then
            If ( HaveKOp( S, P) ) then
               KOp(S, P, IJ) = KOp(S, P, IJ) + D(R, Q, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', S, P, IJ, KOp(S,P,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( R, Q) .eq. Me ) then
            If ( HaveKOp( R, Q) ) then
               KOp(R, Q, IJ) = KOp(R, Q, IJ) + D(S, P, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', R, Q, IJ, KOp(R,S,IJ)
            EndIf
C           
c$$$            If ( Which_Proc( S, Q) .eq. Me ) then
            If ( HaveKOp( S, Q) ) then
               KOp(S, Q, IJ) = KOp(S, Q, IJ) + D(R, P, IJ) * ERI( N ) 
c$$$               Write (6, *) ' Contributing to ', S, Q, IJ, KOp(S,Q,IJ)
            EndIf
C           
         EndDo                  ! N
      EndDo ! IJ
C
      Return
      End
