C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     par3_ints_finished -- Notify other integral processors that we're
C     done generating integrals
C
C SYNOPSIS
      Subroutine Par3_Ints_Finished( Done, NBuf, MxNInt)
      Implicit NONE
      Integer NBuf, MxNInt
      Integer Done(NBuf)
C
C REVISION
C     $Id: par3_ints_finished.F,v 1.1 1993/11/08 19:50:22 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "global.h"
#include "int_pool_private.fh"
C LOCAL VARIABLES
      Integer LoData, HiData, LoBuf, HiBuf, Junk, Proc
C
C     Figure out which buffers are ours.
C
      Call GA_Distribution( ERIBuf_Hdl, GA_NodeID(), LoData, HiData,
     $   LoBuf, HiBuf, Junk)
C
C     Subtract MxNInt from control array entries for all of our
C     buffers. This sends data to all nodes, but happens only once.
C     Each node can make local inquiries to see if all processes
C     are finished, hence almost no communication overhead.
C
      Call IVFil( Nbuf, -(MxNInt+1), Done, 1)
C
      Do Proc = 1, GA_NNodes()
         Call GA_IAcc( BufCtl_Hdl, LoBuf, HiBuf, Proc, Proc, Done, 1, 1)
      EndDo
C
      Return
      End
