C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     par3_process_ints -- Process a batch of integrals into KOp
C
C SYNOPSIS
      Subroutine Par3_Process_Ints( N, ERI, Idx1, Idx2, Idx3, Idx4, C,
     $   D, KOp, MyRow, MyCol, RowDim, ColDim, IJLo, IJHi, NAO,
     $   RBlkSz, CBlkSz, NProc_Row, FPMO, FPAO, T_Den, T_KOp)
      Implicit NONE
      Integer N, MyRow, MyCol, RowDim, ColDim, IJLo, IJHi, NAO,
     $   RBlkSz, CBlkSz, NProc_Row
      Double Precision FPMO, FPAO, T_Den, T_KOp
      Double precision ERI(N)
      Integer Idx1(N), Idx2(N), Idx3(N), Idx4(N)
      Double precision C(NAO, *), D(NAO, NAO),
     $   KOp( MyRow:MyRow+RowDim-1, MyCol:MyCol+ColDim-1, IJLo:IJHi)
C
C REVISION
C     $Id: par3_process_ints.F,v 1.1 1993/11/08 19:50:29 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "numerical_constants.fh"
#include "tcgmsg.h"
C LOCAL VARIABLES
      Integer IJ, I, J
      Double precision FPMO1, FPAO1
C
      Do IJ = IJLo, IJHi
         Call Detriangularize(IJ, I, J)
C        
C        Form a density-like beast, D_{\mu \nu}^{ij}
C        from the I and J columns of the MO coefficients.
C        Note that this matrix is NOT symmetric!
C        
         T_Den = T_Den - TCGTime()
C        
         Call Mk_Dij( NAO, C, I, J, D, FPMO1, FPAO1)
C        
         FPMO = FPMO + FPMO1
         FPAO = FPAO + FPAO1
C        
         T_Den = T_Den + TCGTime()
C        
C        Contract the integrals with the densities
C        to form some exchange operators
C        
         T_KOp = T_KOp - TCGTime()
C        
         Call Par3_Int_into_KOp(N, Idx1, Idx2, Idx3, Idx4, ERI,
     $      NAO, 1, D, KOp(MyRow, MyCol, IJ),
     $      RBlkSz, CBlkSz, NProc_Row, NodeID(),
     $      MyRow, MyCol, RowDim, ColDim,
     $      FPMO1, FPAO1)
C        
         FPMO = FPMO + FPMO1
         FPAO = FPAO + FPAO1
C        
         T_KOp = T_KOp + TCGTime()
C        
      EndDo                     ! IJ
C     
      Return
      End
