C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C	aoints -- compute AO 2-electron integrals and plop them into
C	an array
C
C SYNOPSIS
      Subroutine AOInts( NShell, A, NBF)
      Implicit NONE
      Integer NShell, NBF
      Double Precision A(NBF, NBF, NBF, NBF)
C
C REVISION
C     $Id: aoints.F,v 1.1 1993/08/30 21:25:23 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "stdio.fh"
#include "integral_api.fh"
#include "precision.h"
C LOCAL VARIABLES
      Integer IEnv, Val_Off, I_Off, J_Off, K_Off, L_Off, MxNInt,
     $    Scr_Off, LScratch
      Integer IShell, JShell, KShell, LShell, LHi, NInts
      Integer I, J, K, L, N, TotInt, Large, LgUniq
      Logical LResult
C
C     Get integral evaluation arrays from the memory allocator
C
      LResult = Push_TwoInt()
      LResult = Get_Index_TwoInt( IEnv, Val_Off, I_Off, J_Off, K_Off,
     $    L_Off, MxNInt, Scr_Off, LScratch)
      If ( .NOT. LResult ) Then
         Write (LuErr, *) ' Bad news trying to get indices.'
         STOP
      EndIf
      Write (LuOut, *) 'Integral environment ', IEnv, MxNInt, LScratch
C
C     Clear out the tensor that is going to hold these guys
C
      Call DVZER(NBF**4, A, 1)
C
C     Generate the integrals
C
      TotInt = 0
      LgUniq = 0
C
      do ishell = 1, nshell
         do jshell = 1, ishell
            do kshell = 1, ishell
               lhi = kshell
               if (ishell .eq. kshell) lhi = jshell
               do lshell = 1, lhi
                  call twoint(ienv, ishell, jshell, kshell, lshell,
     &                 Dbl_MB( Val_Off), Int_MB( I_Off),
     &                 Int_MB( J_Off), Int_MB( K_Off),
     &                 Int_MB( L_Off), nints,
     &                 Dbl_MB(Scr_Off), lscratch,
     &                 .true.,.true.)
C
C                 Plop the integrals into the proper tensor elements
C
                  TotInt = TotInt + NInts
C
                  Do N = 1, NInts
                     I = Int_MB( I_Off + N - 1)
                     J = Int_MB( J_Off + N - 1)
                     K = Int_MB( K_Off + N - 1)
                     L = Int_MB( L_Off + N - 1)
c$$$                     Write (11, *) I, J, K, L, Dbl_MB(Val_Off+N-1)
C
                     If ( Abs( Dbl_MB( Val_Off + N - 1 ) )
     $                    .gt. 1.0d-9) LgUniq = LgUniq + 1
                     A(I,J,K,L) = Dbl_MB( Val_Off + N - 1 )
                     A(J,I,K,L) = Dbl_MB( Val_Off + N - 1 )
                     A(I,J,L,K) = Dbl_MB( Val_Off + N - 1 )
                     A(J,I,L,K) = Dbl_MB( Val_Off + N - 1 )
                     A(K,L,I,J) = Dbl_MB( Val_Off + N - 1 )
                     A(L,K,I,J) = Dbl_MB( Val_Off + N - 1 )
                     A(K,L,J,I) = Dbl_MB( Val_Off + N - 1 )
                     A(L,K,J,I) = Dbl_MB( Val_Off + N - 1 )
C
                  EndDo
               enddo
            enddo
         enddo
      enddo
C
      Large = 0
      Do 2000 L = 1, NBF
         Do 2010 K = 1, NBF
            Do 2020 J = 1, NBF
               Do 2030 I = 1, NBF
                  If ( Abs( A(I, J, K, L) ) .gt. 1.0d-9 )
     $                 Large = Large + 1
 2030          Continue
 2020       Continue
 2010    Continue
 2000 Continue
C
      Write (LuOut, *) Large, ' AO integrals (', LgUniq,
     $     ' unique) in ', NBF**4, ' tensor elements.'
C
      LResult = Pop_TwoInt()
C
      Return
      End
