C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     hlfxf13 -- perform a very simple AO --> MO transformation on the
C     two-electron integrals
C
C SYNOPSIS
      Subroutine Hlfxf13( A, B, C, NBF, NOcc)
      Implicit NONE
      Integer NBF, NOcc
      Double Precision A(NBF, NBF, NBF, NBF), B(NBF, NBF, NBF, NBF),
     $     C(NBF, NBF)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "numerical_constants.fh"
#include "precision.h"
C FUNCTIONS
      Double Precision DDOT
      External DDOT
C
C LOCAL VARIABLES
      Integer I, J, K, L, P, Q, R, S, Ierr
C
      Do 1030 P = 1, NBF
         Do 1000 L = 1, NBF
            Do 1010 K = 1, NBF
               Do 1020 J = 1, NBF
                  B(P, J, K, L) = DDOT( NBF, C(1, P), 1,
     $                 A(1, J, K, L), 1)
 1020          Continue
 1010       Continue
 1000    Continue
 1030 Continue
c$$$C
c$$$      Do 2000 L = 1, NBF
c$$$         Do 2010 K = 1, NBF
c$$$            Do 2020 Q = 1, NBF
c$$$               Do 2030 P = 1, NBF
c$$$                  B(P, Q, K, L) = DDOT( NBF, C(1, Q), 1,
c$$$     $                 A(P, 1, K, L), NBF)
c$$$ 2030          Continue
c$$$ 2020       Continue
c$$$ 2010    Continue
c$$$ 2000 Continue
C
      Do 3000 L = 1, NBF
         Do 3010 R = 1, NBF
            Do 3020 Q = 1, NBF
               Do 3030 P = 1, NBF
                  A(P, Q, R, L) = DDOT( NBF, C(1, R), 1,
     $                 B(P, Q, 1, L), NBF**2)
 3030          Continue
 3020       Continue
 3010    Continue
 3000 Continue
c$$$C
c$$$      Do 4000 S = 1, NBF
c$$$         Do 4010 R = 1, NBF
c$$$            Do 4020 Q = 1, NBF
c$$$               Do 4030 P = 1, NBF
c$$$                  A(P, Q, R, S) = DDOT( NBF, C(1, S), 1,
c$$$     $                 B(P, Q, R, 1), NBF**3)
c$$$ 4030          Continue
c$$$ 4020       Continue
c$$$ 4010    Continue
c$$$ 4000 Continue
C
      Return
      End
