C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     toy1 -- simple-minded E(2) calculations
C
C SYNOPSIS
      Subroutine Toy1( NShell, NAOBF, NOcc, C_Hdl,
     $     F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl)
      Implicit NONE
      Integer NShell, NAOBF, NOcc, C_Hdl, F_Hdl, FAO_Hdl,
     $   S_Hdl, QProj_Hdl, SInv_Hdl
C
C REVISION
C     $Id: toy1.F,v 1.1 1993/08/30 21:25:47 gg502 Exp $
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "stdio.fh"
#include "mafdecls.h"
#include "numerical_constants.fh"
#include "precision.h"
C FUNCTIONS
      Double Precision Toy1_GenE2
      External Toy1_GenE2
      Double precision DNRM2
      External DNRM2
C
C LOCAL VARIABLES
      Logical LResult
      Integer C_Ind, F_Ind, FAO_Ind, S_Ind, QProj_Ind,
     $   SInv_Ind
      Integer D_Hdl, Wrk1_Hdl, Wrk2_Hdl, Metric_Hdl, IPiv_Hdl, T2_Hdl,
     $   IntB_Hdl, Wrk3_Hdl, Wrk4_Hdl, F_Ext_Hdl, IntA_Hdl
      Integer D_Ind, Wrk1_Ind, Wrk2_Ind, Metric_Ind, IPiv_Ind, T2_Ind,
     $   IntB_Ind, Wrk3_Ind, Wrk4_Ind, F_Ext_Ind, IntA_Ind
      Integer ISeed, IErr, Info, LWrk1
      Double Precision E2
C
      Write (LuOut, *) 'Starting Toy1 calculations'
C
C
C     **********************************************
C     * Form MO basis 2-electron integrals in IntA *
C     **********************************************
C     1) Load AO integrals into the array
C
      LResult = MA_Push_Get( MT_DBL, NAOBF**4, 'Integrals', IntA_Hdl,
     $   IntA_Ind)
      LResult = MA_Push_Get( MT_Dbl, NAOBF**4, 'T2 amplitudes',
     $   T2_Hdl, T2_Ind)
      LResult = MA_Get_Index( C_Hdl, C_Ind)
      LResult = MA_Get_Index( F_Hdl, F_Ind)
C
      If ( .FALSE. ) then
         Call AOInts( NShell, DBL_MB( IntA_Ind), NAOBF )
C
C        MO coefficient matrix already allocated & filled by Setup routine.
C        IntB is a scratch array.
C
         LResult = MA_Get_Index( C_Hdl, C_Ind)
         LResult = MA_Push_Get( MT_DBL, NAOBF**4, 'XForm scratch',
     $      IntB_Hdl, IntB_Ind)
C
C        2) Four-index transformation to MO basis
C        
         Call XForm0( DBL_MB( IntA_Ind), DBL_MB( IntB_Ind),
     $      DBL_MB( C_Ind), NAOBF, NOcc)
         LResult = MA_Pop_Stack( IntB_Hdl )
C
C        ************************************************************
C        * Form T amplitudes, compute enery (canonical HF MO basis) *
C        ************************************************************
C        Fock matrix allocated & filled by Setup routine
C
         LResult = MA_Get_Index( F_Hdl, F_Ind)
C
         Call Toy1_CanMOT2( DBL_MB(IntA_Ind), Dbl_MB(T2_Ind),
     $      Dbl_MB(F_Ind), NOcc, NAOBF)
C
         E2 = Toy1_GenE2( DBL_MB(IntA_Ind), DBL_MB(T2_Ind),
     $      NOcc+1, NAOBF, NOcc+1, NAOBF, 1, NOcc, 1, NOcc, NAOBF)
         Write (LuOut, *) 'cHF MO E(2) = ', E2
      EndIf
C
C     **************************
C     * Decanonicalize the MOs *
C     **************************
C
      If ( .FALSE. ) then
      LResult = MA_Push_Get( MT_DBL, NAOBF**2, 'decanonicalizer',
     $     D_Hdl, D_Ind)
c$$$      Call DGEONE( NAOBF, NAOBF, Dbl_MB( D_Ind), NAOBF)
C
C     Make occupied-occupied and virtual-virtual blocks separately
C     with no coupling between them, so the orbitals will remain
C     Hartree-Fock, but simply won't be canonical.
C
      Call DGEZER( NAOBF, NAOBF, DBL_MB(D_Ind), NAOBF)
      ISeed = 0
      Call DGERAN( NOcc, NOcc, DBL_MB( D_Ind), NAOBF, ISeed)
      Call DGERAN( NAOBF-NOcc, NAOBF-NOcc,
     $     DBL_MB( D_Ind + NOcc * (NAOBF+1) ), NAOBF, ISeed)
c$$$C
c$$$      Call DGEWR( NAOBF, NAOBF, DBL_MB(D_Ind), NAOBF, 0, 0, LuOut,
c$$$     $     'decanonicalizer', 80, 'E13.6', IErr)
C
C     Now insure it is unitary.  Metric (S) is the unit matrix.
C
      LResult = MA_Push_Get( MT_DBL, NAOBF, 'Work1',
     $    Wrk1_Hdl, Wrk1_Ind)
      LResult = MA_Push_Get( MT_DBL, NAOBF, 'Work2',
     $    Wrk2_Hdl, Wrk2_Ind)
      LResult = MA_Push_Get( MT_DBL, NAOBF * NAOBF, 'Metric',
     $    Metric_Hdl, Metric_Ind)
C
      Call DGEONE( NAOBF, NAOBF, DBL_MB(Metric_Ind), NAOBF)
      Call OrthV2( NAOBF, NAOBF, DBL_MB(D_Ind), DBL_MB(Metric_Ind),
     $     DBL_MB( wrk1_Ind ), DBL_MB( wrk2_Ind ))
C
c$$$      Call DGEWR( NAOBF, NAOBF, DBL_MB(D_Ind), NAOBF, 0, 0, LuOut,
c$$$     $     'unitary decanonicalizer', 80, 'E13.6', IErr)
C
      LResult = MA_Pop_Stack( Metric_Hdl)
      LResult = MA_Pop_Stack( Wrk2_Hdl)
      LResult = MA_Pop_Stack( Wrk1_Hdl)
C
C     ******************************************
C     * Transform Fock matrix to the new basis *
C     ******************************************
C     Use IntB as scratch for both 1- and 2-electron transformation
C
      LResult = MA_Push_Get( MT_Dbl, NAOBF**4, 'Scratch',
     $   IntB_Hdl, IntB_Ind)
C
      Call DGEMM('T', 'normal', NAOBF, NAOBF, NAOBF, FP_One,
     $     DBL_MB( D_Ind ), NAOBF, DBL_MB( F_Ind), NAOBF,
     $     FP_Zero, DBL_MB( IntB_Ind ), NAOBF)
      Call DGEMM('N', 'N', NAOBF, NAOBF, NAOBF, FP_One,
     $     DBL_MB( IntB_Ind ), NAOBF, DBL_MB( D_Ind), NAOBF,
     $     FP_Zero, DBL_MB( F_Ind ), NAOBF)
c$$$C
c$$$      Call DGEWR( NAOBF, NAOBF, DBL_MB(F_Ind), NAOBF, 0, 0, LuOut,
c$$$     $     'ncHF Fock matrix', 80, 'E13.6', IErr)
C
C     *******************************************************
C     * Transform the 2-electron integrals to the new basis *
C     *******************************************************
C
      Call XForm0( DBL_MB( IntA_Ind), DBL_MB( IntB_Ind),
     $     DBL_MB( D_Ind), NAOBF, NOcc)
C
      LResult = MA_Pop_Stack( IntB_Hdl )
C
C     **************************************************************
C     * Compute T amplitudes and energy (noncanonical HF MO basis) *
C     **************************************************************
C
      LResult = MA_Push_Get( MT_DBL, NAOBF, 'ncMOT2 Scratch',
     $    Wrk1_Hdl, Wrk1_Ind)
      LResult = MA_Push_Get( MT_DBL, NAOBF*NAOBF, 'ncMOT2 Scratch 2',
     $    Wrk2_Hdl, Wrk2_Ind)
C
      Call Toy1_ncMOT2( DBL_MB(IntA_Ind), Dbl_MB(T2_Ind),
     $     Dbl_MB(F_Ind), Dbl_MB(Wrk1_Ind), Dbl_MB( Wrk2_Ind),
     $     NOcc, NAOBF)
C
      E2 = Toy1_GenE2( DBL_MB(IntA_Ind), Dbl_MB(T2_Ind),
     $   NOcc+1, NAOBF, NOcc+1, NAOBF, 1, NOcc, 1, NOcc, NAOBF)
      Write (LuOut, *) 'ncHF MO E(2) = ', E2
C
C     If we're going to go on with noncanonical orbitals, subsume the
C     transformation into the MO eigenvectors, C.
C
      Call DGEMM('N', 'N', NAOBF, NAOBF, NAOBF,
     $   FP_One, Dbl_MB( C_Ind), NAOBF, Dbl_MB( D_Ind), NAOBF,
     $   FP_Zero, Dbl_MB( Wrk2_Ind), NAOBF)
      Call DGECOP('N', NAOBF, NAOBF, Dbl_MB(Wrk2_Ind), NAOBF,
     $   Dbl_MB(C_Ind), NAOBF)
C
      LResult = MA_Pop_Stack( Wrk2_Hdl )
      LResult = MA_Pop_Stack( Wrk1_Hdl )
      LResult = MA_Pop_Stack( D_Hdl )
C      
      EndIf
C
C     ***********************************************
C     * Form the integrals in the mixed AO/MO basis *
C     ***********************************************
C
C     C' (mu, lambda | nu, sigma) C --> (I, lambda | J, sigma)
C
      LResult = MA_Push_Get(MT_Dbl, NAOBF**4, 'back xform scratch',
     $   IntB_Hdl, IntB_Ind)
      LResult = MA_Get_Index( QProj_Hdl, QProj_Ind)
C
      Call AOInts( NShell, DBL_MB( IntA_Ind), NAOBF )
      Call HlfXf13( DBL_MB( IntA_Ind), DBL_MB( IntB_Ind),
     $     DBL_MB( C_Ind), NAOBF, NOcc)
C
      LResult = MA_Pop_Stack( IntB_Hdl )
C
      LResult = MA_Get_Index( FAO_Hdl, FAO_Ind)
      LResult = MA_Get_Index( S_Hdl, S_Ind)
      LResult = MA_Get_Index( QProj_Hdl, QProj_Ind)
      LResult = MA_Push_Get(MT_Dbl, NAOBF*NAOBF, 'F ext.',
     $   F_Ext_Hdl, F_Ext_Ind)
      LResult = MA_Push_Get(MT_Dbl, NAOBF*NAOBF, 'scratch 1',
     $   Wrk1_Hdl, Wrk1_Ind)
C
C     Project AO Fock matrix into external basis
C
      Call DGEMM( 'N', 'N', NAOBF, NAOBF, NAOBF,
     $   FP_One, Dbl_MB( QProj_Ind), NAOBF, Dbl_MB( FAO_Ind), NAOBF,
     $   FP_Zero, Dbl_MB(Wrk1_Ind), NAOBF)
      Call DGEMM( 'N', 'T', NAOBF, NAOBF, NAOBF,
     $   FP_One, Dbl_MB( Wrk1_Ind), NAOBF, Dbl_MB( QProj_Ind), NAOBF,
     $   FP_Zero, Dbl_MB(F_Ext_Ind), NAOBF)
C
      LResult = MA_Pop_Stack( Wrk1_Hdl)
c$$$C
c$$$      Call DGECOP('N', NAOBF, NAOBF, Dbl_MB(F_Ext_Ind), NAOBF,
c$$$     $   Dbl_MB(FAO_Ind), NAOBF)
c$$$      Call DGEWR( NAOBF, NAOBF, DBL_MB(F_Ext_Ind), NAOBF, 0, 0, LuOut,
c$$$     $     'External Fock matrix', 80, 'E13.6', IErr)
C
C     *********************************************************
C     * Form T amplitudes, compute energy (mixed MO/AO basis) *
C     *********************************************************
C
      LResult = MA_Push_Get(MT_Dbl, NAOBF*NAOBF, 'scratch 1',
     $   Wrk1_Hdl, Wrk1_Ind)
      LResult = MA_Push_Get(MT_Dbl, NAOBF*NAOBF, 'scratch 2',
     $   Wrk2_Hdl, Wrk2_Ind)
      LResult = MA_Push_Get(MT_Dbl, NAOBF*NAOBF, 'scratch 3',
     $   Wrk3_Hdl, Wrk3_Ind)
      LResult = MA_Push_Get(MT_Dbl, NAOBF**4, 'scratch 4',
     $   Wrk4_Hdl, Wrk4_Ind)
C
      LResult = MA_Get_Index( FAO_Hdl, FAO_Ind)
      LResult = MA_Get_Index( S_Hdl, S_Ind)
      LResult = MA_Get_Index( SInv_Hdl, SInv_Ind)
      LResult = MA_Get_Index( QProj_Hdl, QProj_Ind)
C
      Call Toy1_MixedT2( DBL_MB(IntA_Ind), Dbl_MB(T2_Ind),
     $   Dbl_MB(Wrk4_Ind),
     $   Dbl_MB(F_Ind), Dbl_MB(FAO_Ind), Dbl_MB(S_Ind),
     $   Dbl_MB(Wrk1_Ind), Dbl_MB( Wrk2_Ind), Dbl_MB(Wrk3_Ind),
     $   Dbl_MB(QProj_Ind), Dbl_MB(F_Ext_Ind), Dbl_MB(C_Ind),
     $   Dbl_MB(SInv_Ind), 
     $   NOcc, NAOBF)
C
      LResult = MA_Pop_Stack( Wrk4_Hdl)
      LResult = MA_Pop_Stack( Wrk3_Hdl)
      LResult = MA_Pop_Stack( Wrk2_Hdl)
      LResult = MA_Pop_Stack( Wrk1_Hdl)
c$$$      LResult = MA_Pop_Stack( SInv_Hdl)
      LResult = MA_Pop_Stack( F_Ext_Hdl)
C
      E2 = Toy1_GenE2( DBL_MB(IntA_Ind), Dbl_MB(T2_Ind),
     $   1, NAOBF, 1, NAOBF, 1, Nocc, 1, NOcc, NAOBF)
      Write (LuOut, *) 'cHF AO/MO E(2) = ', E2
C     
C     ***************************
C     * Cleanup after ourselves *
C     ***************************
C
      LResult = MA_Pop_Stack( T2_Hdl )
      LResult = MA_Pop_Stack( IntA_Hdl )
C
      Write (LuOut, *) 'Done with Toy1 calculations'
C
      Return
      End
