C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     Toy1_CanMOT2 -- compute second order T2 from canonical HF MOs
C
C SYNOPSIS
      Subroutine Toy1_CanMOT2( MOInt, T2, F, NOcc, NBF)
      Implicit NONE
      Integer NOcc, NBF
      Double Precision MOInt(NBF, NBF, NBF, NBF),
     $     T2( NBF, NBF, NBF, NBF), F(NBF, NBF)
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "numerical_constants.fh"
C LOCAL VARIABLES
      Double Precision Den
      Integer I, J, A, B
C
      Call DVZER( NBF**4, T2, 1)
C
      Do 1000 I = 1, NOcc
         Do 1010 J = 1, NOcc
C
            Do 1020 A = NOcc + 1, NBF
               Do 1030 B = NOcc + 1, NBF
C
C                 Form denominator
C
                  Den = F(I, I) + F(J, J) - F(A, A) - F(B, B)
C
C                 alpha-alpha + beta-beta contributions
C
                  T2(A, B, I, J) =
     $                 ( MOInt(I, A, J, B) - MOInt(I, B, J, A))/Den
C
C                 alpha-beta contribution
C
                  T2(A, B, I, J) = T2(A, B, I, J)
     $                 + MOInt(I, A, J, B) / Den
 1030          Continue
 1020       Continue
C
 1010    Continue
 1000 Continue
      Return
      End
