C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     Toy1_GenE2 -- compute E(2) energy
C
C SYNOPSIS
      Double Precision Function Toy1_GenE2( Integral, T2,
     $   Lo1, Hi1, Lo2, Hi2, Lo3, Hi3, Lo4, Hi4, NBF)
      Implicit NONE
      Integer Lo1, Hi1, Lo2, Hi2, Lo3, Hi3, Lo4, Hi4, NBF
      Double Precision Integral(NBF, NBF, NBF, NBF),
     $     T2(NBF, NBF, NBF, NBF)
C
C     {Lo,Hi}[1234] variables are summation limits based on indices
C     of T2 amplitude.
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "numerical_constants.fh"
#include "stdio.fh"
C LOCAL VARIABLES
      Double Precision EIJ, TIJ
      Integer I, J, A, B, IErr
C
      Toy1_GenE2 = FP_Zero
C
      Do 1000 I = Lo3, Hi3
         Do 1010 J = Lo4, Hi4
c$$$C
c$$$            Write (6, *) 'I, J = ', I, J
c$$$            Call DGEWR( NBF, NBF, T2(1, 1, I, J), NBF, 0, 0,
c$$$     $         LuOut, 'T2 matrix', 80, 'E13.6', IErr)
C
            EIJ = FP_Zero
            TIJ = FP_Zero
C
            Do 1020 A = Lo1, Hi1
               Do 1030 B = Lo2, Hi2
C
C                 Combine everything
C
                  TIJ = TIJ + T2(A, B, I, J)**2
                  EIJ = EIJ + T2(A, B, I, J) * Integral(I, A, J, B)
C
 1030          Continue
 1020       Continue
C
c$$$            Write (6, *) 'T,EIJ(AA+BB+AB) ', I, J, TIJ, EIJ
            Toy1_GenE2 = Toy1_GenE2 +  EIJ
 1010    Continue
 1000 Continue
      Return
      End
