C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C NAME
C     vle2 -- Perform very large MBPT(2) calculations (eventually)
C
C REVISION
C     $Id: vle2.F,v 1.4 1993/11/08 19:48:02 gg502 Exp $
C
C SYNOPSIS
	Program VLE2
        Implicit NONE
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#include "mafdecls.h"
#include "stdio.fh"
#include "exepath.fh"
C
C LOCAL VARIABLES
      Character*4 Program
      Integer StkReq, HepReq, TotMem, TotReq, StkTot, HepTot
      Integer NShell, NAOBF, NMOBF, NFokOp, NOccMO
      Integer C_Hdl, F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, FQ_Hdl
      Integer SInv_Hdl
      Logical LResult
C
C     Set execution path through code
C
      ExePath = 'PAR3'
C
C     Make sure the first executable statement of this program is in this
C     file to keep the debugger from playing stupid games with the source 
C     files.
C
      Program = 'VLE2'
C
C     Initialization of supporting packages
C
      Call PreInitialize
C
C     Read some of the basic input  to estimate memory usage
C
      Call FirstIn( TotMem, NShell, NAOBF, NMOBF, NFokOp, NOccMO)
C
      StkTot = TotMem
      HepTot = 0
      Call Initialize( StkTot, HepTot)
C
C     Prepare an estimate of the memory required for the calculation
C
      Call EstMem( StkReq, HepReq, NAOBF, NMOBF, NFokOp, NOccMO)
C
C     Compare required memory with available memory
C
      TotReq = StkReq + HepReq
      Write (LuOut, 9000) StkReq, StkTot, HepReq, HepTot, TotReq, TotMem
c$$$      If ( TotReq .gt. TotMem ) then
c$$$         Write (LuErr, 9010) 
c$$$         Stop
c$$$      EndIf
 9000 Format(1X, 9X,          ' Estimated', 3X, ' Allocated',
     $     /1X, 'Stack ', 3X, I10,          3X, I10,
     $     /1X, 'Heap  ', 3X, I10,          3X, I10,
     $     /1X, 9X,           '----------', 3X, '----------',
     $     /1X, 'Total ', 3X, I10,          3X, I10)
 9010 Format(1X, 'INSUFFICIENT MEMORY FOR CALCUALTION TO CONTINUE.')
C
C     Perform any setup necessary for the calculation
C
      Call Setup(NAOBF, NMOBF, NOccMO, C_Hdl,
     $     F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
C
C     Do the work
C
      Call Compute(NShell, NAOBF, NOccMO, C_Hdl,
     $     F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
C
C     Do any wrap-up for the calculation
C
      Call WrapUp(NShell, NAOBF, NOccMO, C_Hdl, 
     $     F_Hdl, FAO_Hdl, S_Hdl, QProj_Hdl, SInv_Hdl, FQ_Hdl)
C
C     Termination/cleanup of supporting packages
C
      Call Terminate
C
C
C
      Stop
      End
